import java.io.*;
import java.net.Socket;
import javax.servlet.*;
import javax.servlet.http.*;

public class ChronogramServlet extends DaemonHttpServlet
{
  public void handleClient(Socket client)
  {
  	System.out.println("Tratando pedido de cliente");
  	try {
    new ChronogramConnection(client).start();
    }
    catch(Exception e) {
    	System.out.println("Nao consegui conectar cliente");
      System.out.println(e);
    }
  }

  public void doGet(HttpServletRequest req, HttpServletResponse res) 
         throws ServletException, IOException 
  {
    res.setContentType("text/html");
    Writer out = new OutputStreamWriter(res.getOutputStream());
    out.write("<html><body>");
    out.write("ChronogramServlet: doGet");
    out.write("</body></html>");
    out.flush();
    out.close();
  }
}

class ChronogramConnection extends Thread
{
  Socket client;

  ChronogramConnection(Socket client)
  {
    //System.out.println("real path = " + servlet.getServletContext().getRealPath("/servlet"));
    this.client = client;
    setPriority(NORM_PRIORITY - 1);
  }

  public void run()
  {
    try {
      AgentGifEncoder agentGifEncoder = new AgentGifEncoder();
      agentGifEncoder.run(client);
    }
    catch(Exception e) {
    	System.out.println("Erro no agentgifencoder");
      System.out.println(e);
    }
  }


}
