import java.applet.*;
import java.awt.*;
import java.io.*;
import com.jrefinery.data.DefaultCategoryDataset;
import com.jrefinery.chart.ChartFactory;
import com.jrefinery.chart.JFreeChart;
import com.jrefinery.chart.ChartPanel;
import com.jrefinery.chart.plot.PiePlot;


public class BarChart3D extends Applet{
   static String series1;
   static String series2;
   static String series3;
   static String title;
   static String titleano;
   static String titlevalor;

   public void init() {
      int NumElem,i;

      JFreeChart chart;
      ChartPanel panel2;
      DefaultCategoryDataset data;
      
      
      title = this.getParameter("title");
      titleano = this.getParameter("titleano");
      titlevalor = this.getParameter("titlevalor");
      NumElem = Integer.parseInt(getParameter("numelem"));
      series1 = this.getParameter("series1");
      series2 = this.getParameter("series2");
      series3 = this.getParameter("series3");
      data = new DefaultCategoryDataset();

      //estudar jfreechart.java e chartfactory.java, sobre alteracoes no grafico de barras.


      for (i=0;i<NumElem;i++)
      {
         if ( series1 != null )
         {
//            System.out.println("iii = "+i+" estado = "+(String)(getParameter("label" + (i+1)))+" valor = "+(String)getParameter("serie1_values" + (i+1)));

            if ((String)getParameter("serie1_values" + (i+1)) != null)
            {
               data.setValue( Float.parseFloat((String)(getParameter("serie1_values" + (i+1)))), series1, (String)(getParameter("label" + (i+1))));
            }
            else
            {
               data.setValue( 0.00, series1, (String)(getParameter("label" + (i+1))));
            }
         }

         if ( series2 != null ) 
         {
            if ((String)getParameter("serie2_values" + (i+1)) != null)
            {
               data.setValue(Float.parseFloat((String)(getParameter("serie2_values" + (i+1)))), series2, (String)(getParameter("label" + (i+1))));
            }
            else
            {
               data.setValue(0.00, series2, (String)(getParameter("label" + (i+1))));
            }
         }
      
         if ( series3 != null  ) 
         {
            data.setValue(Float.parseFloat((String)(getParameter("serie3_values" + (i+1)))), series3, (String)(getParameter("label" + (i+1))));
         }
      }
      
      /**
       * Creates a vertical bar chart with default settings.
       *
       * @param title  the chart title.
       * @param categoryAxisLabel  the label for the category axis.
       * @param valueAxisLabel  the label for the value axis.
       * @param data  the dataset for the chart.
       * @param legend  a flag specifying whether or not a legend is required.
       * @param tooltips  configure chart to generate tool tips?
       * @param urls  configure chart to generate URLs?
       *
       * @return a vertical bar chart.
      */
      chart =  ChartFactory.createVerticalBarChart3D(title,
                                                    titleano,
                                                    titlevalor,
                                                    data,
                                                    true,
                                                    true,
                                                    false);
 

      panel2 = new ChartPanel(chart);

      // Pano de fundo de cor branca
      chart.setBackgroundPaint(Color.white);


      //Estende o panel ate que o mesmo ocupe o tamanho determinado para o applet
      setLayout(new BorderLayout());

       //Visualiza o applet
      add(panel2);

  }

}