dofile( "lua/acessabd.lua" )


function mostraSiglasOrgSelect( condicoes )
   local result = {}
   local i
   
   result = ConsultaBD2( "orgao", "org_cod, org_sigla", condicoes , nil )
   
   if ( result ) then      
      if javafc then
      write( '<SELECT NAME="cod" '..javafc..'>\n' )
      else	
      write( '<SELECT NAME="cod">\n' )
      end      
      i = 1
      while ( result[i] ) do
         write( '<OPTION VALUE="' .. result[i][1] .. '">'.. result[i][2] .. '\n' )
         i = i + 1
      end   
      if sel_todos then
         write( '<OPTION VALUE="todos">Todos'..'\n' )
      end
      write( '</SELECT>\n' )
   end
end


function mostraNomesOrgSelect( condicoes )
   local result = {}
   local i
   
   result = ConsultaBD2( "orgao", "org_cod, org_nome, org_sigla", condicoes , nil )
   
   if ( result ) then
      write( '<SELECT NAME="cod">\n' )   
      i = 1
      while ( result[i] ) do
         write( '<OPTION VALUE="' .. result[i][1] .. '">'.. result[i][2] .. '\n' )
         i = i + 1
      end   
      write( '</SELECT>\n' )
   end
end


function mostraNomesSiglasSelect( condicoes )
   local result = {}
   local i
   
   result = ConsultaBD2( "orgao", "org_cod, org_nome, org_sigla", condicoes , nil )
   
   if ( result ) then
      write( '<SELECT NAME="cod">\n' )   
      i = 1
      while ( result[i] ) do
         write( '<OPTION VALUE="' .. result[i][1] .. '">'.. result[i][2] .. ' - ' .. result[i][3] .. '\n' )
         i = i + 1
      end   
      if sel_todos then
         write( '<OPTION VALUE="todos">Todos'..'\n' )
      end     
      write( '</SELECT>\n' )
   end
end


function mostraNomesSiglasSelectMult( condicoes )
   local result = {}
   local i
   
   result = ConsultaBD2( "orgao", "org_cod, org_nome, org_sigla", condicoes , nil )
   
   if ( result ) then
      write( '<SELECT NAME="cod" multiple SIZE ="3">\n' )   
      i = 1
      while ( result[i] ) do
         write( '<OPTION VALUE="' .. result[i][1] .. '">'.. result[i][2] .. ' - ' .. result[i][3] .. '\n' )
         i = i + 1
      end
      write( '<OPTION VALUE="todos">Todos'..'\n' )         
      write( '</SELECT>\n' )
   end
end


function retornaRespOrg( cod )
   local result_cod  = {}
   local result_nome = {}
      
   if ( cod ) then
     result_cod  = ConsultaBD2( "orgao", "pes_cod_resp", "org_cod = '" .. cod .. "'" , nil )
     result_nome = ConsultaBD2( "pessoal", "pes_nome", "pes_cod = '" .. result_cod[1][1] .. "'" , nil )
     return result_nome[1][1]
   else  
      return 'Cdigo do rgo Invlido!'
   end
end


function retornaRespUnid( cod )
   local result_cod  = {}
   local result_nome = {}
      
   if ( cod ) then
     result_cod  = ConsultaBD2( "unidade", "pes_cod_resp", "unid_cod = '" .. cod .. "'" , nil )
     result_nome = ConsultaBD2( "pessoal", "pes_nome", "pes_cod = '" .. result_cod[1][1] .. "'" , nil )
     return result_nome[1][1]
   else  
      return 'Cdigo da Unidade Invlido!'
   end
end


function retornaRespSubOrg( cod )
   local result_cod  = {}
   local result_nome = {}
      
   if ( cod ) then
     result_cod  = ConsultaBD2( "orgao", "pes_cod_sub", "org_cod = '" .. cod .. "'" , nil )
     result_nome = ConsultaBD2( "pessoal", "pes_nome", "pes_cod = '" .. result_cod[1][1] .. "'" , nil )
     return result[1][1]
   else  
      return 'Cdigo do rgo Invlido!'
   end
end
   

function retornaNomeOrg( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "orgao", "org_nome", "org_cod = '" .. cod .. "'" , nil )
      return result[1][1]
   else
      return 'Cdigo do rgo Invlido!'
   end
end


function retornaSiglaOrg( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "orgao", "org_sigla", "org_cod = '" .. cod .. "'" , nil )
      return result[1][1]
   else
      return 'Cdigo do rgo Invlido!'
   end
end


-- Retorna uma tabela com os codigos de todas as unidades do orgao ( entro como parametro o codigo do orgao)
function retornaRelCodUnidOrg( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "unidade", "unid_cod", "org_cod = '" .. cod .. "'" , nil )
      return result
   else
      return 'Cdigo do rgo Invlido!'
   end
end


-- Retorna uma tabela com os codigos de todas as unidades do orgao ( entro como parametro o codigo do orgao)
function retornaRelSiglaUnidOrg( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "unidade", "unid_sigla", "org_cod = '" .. cod .. "'" , nil )
      return result
   else
      return 'Cdigo do rgo Invlido!'
   end
end


function retornaNomeUnid( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "unidade", "unid_nome", "unid_cod = '" .. cod .. "'" , nil )
      return result[1][1]
   else
      return 'Cdigo do Unidade Invlido!'
   end
end


function retornaSiglaUnid( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "unidade", "unid_sigla", "unid_cod = '" .. cod .. "'" , nil )
      return result[1][1]
   else
      return 'Cdigo do Unidade Invlido!'
   end
end


function mostraInfoOrgao( cod )
   write( '<TABLE WIDTH="80%" BORDER="0" ALIGN="CENTER">\n')
   write( '<TR>\n' )
   write( '<TD>Nome do rgo</TD>\n' )
   write( '<TD>' .. retornaNomeOrg(cod) .. '</TD>\n' )
   write( '</TR>\n' )
   write( '<TR>\n' )
   write( '<TD>Responsvel</TD>\n' )
   write( '<TD>' .. retornaRespOrg(cod) .. '</TD>\n' )
   write( '</TR>\n' )
   write( '</TABLE>\n')  
end