-- ------------------------------------------------------------------------------
-- Valores Globais
-- ------------------------------------------------------------------------------
   applet_width  = 750
   applet_height = 400


-- --------------------------------------------------------------- 
-- funo que retorna o responsavel por tal atividade		   
-- --------------------------------------------------------------- 
function obtem_responsavel(sigla,fase,atividade) 
  DBOpen(SIGMA_DSN)
  
  if fase and (fase ~= '' and fase ~= 'vazio')  then

    str = "SELECT ativ_resp "..
    	    "FROM atividades "..
          "WHERE proj_sigla = \'"..sigla.."\' AND fase_nome = \'"..fase.."\' "..
	        "AND ativ_nome = \'"..forca_plic(atividade).."\'"

  else
    DBClose()
    return nil		
  end
  
  DBExec(str)

  temp = DBRow()
  if temp == nil then
    DBClose()
    return nil
  end
  
  chave=temp.ativ_resp
  -- Obtem nome do responsavel
      local nome=''
      if temp.ativ_resp and temp.ativ_resp~='' then
        str_aux = "SELECT pess_nome_guerra FROM pessoal WHERE "..
        "pess_chave = '"..temp.ativ_resp.."'"
        DBExec(str_aux)
        temp2= DBRow()
        if temp2 then
          nome=temp2.pess_nome_guerra
	      else
	        if temp.ativ_resp~='' and temp.ativ_resp~="(No Especificado)" then
	           nome=ObtemPessoaAntiga(temp.ativ_resp)
			       ant='ok'
	           if nome=='' or nome==nil then
		            nome='(No consta na Base de Dados)'
		         end
	        end
        end
      end
  
  DBClose()

  return nome,chave,ant
end


function BuscaRestr(origem)

  local temp
  
  if (nivel==30 or nivel==32 or nivel==52) and proj_stat=='l' then
  
    -- sql que verifica existncia de restries para um determinado projeto
	temp = " SELECT DISTINCT r.proj_sigla, r.fase_nome, restr_tipo, restr_atend"
			.." FROM restricoes r, pessoal, atividades a"
	              	.." WHERE a.proj_sigla=\'"..cgi.SiglaProj.."\'"
			.." AND a.fase_nome=\'Restries\'"
			.." AND restr_origem=\'"..origem.."\'"
			.." AND r.proj_sigla=a.proj_sigla"
			.." AND r.fase_nome=a.fase_nome"
			.." AND a.ativ_nome=r.ativ_nome"
			.." AND pess_chave=ativ_resp"
			.." AND pess_chave='"..chave.."'"
  elseif nivel==31 or nivel==51 and proj_stat=='l' then
  
    -- sql que verifica existncia de restries para um determinado projeto
	temp = " SELECT DISTINCT r.proj_sigla, r.fase_nome, restr_tipo, restr_atend"
			.." FROM restricoes r, pessoal, atividades a"
	              	.." WHERE a.proj_sigla=\'"..cgi.SiglaProj.."\'"
			.." AND a.fase_nome=\'Restries\'"
			.." AND restr_origem=\'"..origem.."\'"
			.." AND r.proj_sigla=a.proj_sigla"
			.." AND r.fase_nome=a.fase_nome"
			.." AND a.ativ_nome=r.ativ_nome"
			.." AND pess_chave=ativ_resp"
			.." AND pess_sigla_setor='"..entidade.."'"
  else
    -- sql que verifica existncia de restries para um determinado projeto
	temp = "SELECT DISTINCT proj_sigla, fase_nome, restr_tipo, restr_atend"
	            .." FROM restricoes"
                .." WHERE proj_sigla=\'"..cgi.SiglaProj.."\'"
				.." AND fase_nome=\'Restries\'"
				.." AND restr_origem=\'"..origem.."\'"
  end

  DBOpen(SIGMA_DSN)
  DBExec(temp)
  local result = DBRow()
  DBClose()
  return result
end

-- ------------------------------------------------------------------------------
-- Funcoes Auxiliares
-- ------------------------------------------------------------------------------
function IncrementaData(data)

  if data and data~='' then
    data=gsub(data, "^(%d%d%d%d)(%d%d)(%d%d)", "%1,%2,%3")
    data=sec2date(date2sec(data,"%Y,%m,%d") + 172800,"%Y%m%d")
  end

  return data
end

function invalido( v )
  if not v or v == 'NAO_CONHECIDA' or v == '' then
     return 1
  else 
     return nil 
  end
end

function formata_data( data )
  if not data or data == '' then
     return nil
  else return strsub( data, 7, 8)..'/'..
              strsub( data, 5, 6)..'/'..
              strsub( data, 1, 4) 
  end
end

function converte_data( data )
  if invalido( data ) then
     return nil
  else
     return date2sec( formata_data( data ), "%d/%m/%Y") 
  end
end

function avalia( data1, op, data2)
  if flag == 1 then
     print('<br>2',data1, op, data2)
  end
  return dostring( 'return '..converte_data( data1 )..op..converte_data( data2 ) )
end

function valor( campo )
  if invalido( campo ) then
    return 'NIL'
  else
    return campo
  end
end

function min_valor( valor1, valor2, valor3 )
  local m

  if invalido(valor1) then 
    m = valor2
  elseif invalido(valor2) or avalia( valor1, '<', valor2 ) then
    m = valor1
  else 
    m = valor2 
  end

  if invalido(valor3) then 
    return m
  elseif invalido(m) or avalia( valor3, '<', m ) then
    return valor3
  else 
    return m 
  end
end

function max_valor( valor1, valor2, valor3 )
  local m

  if invalido(valor1) then 
    m = valor2
  elseif invalido(valor2) or avalia( valor1, '>', valor2 ) then
    m = valor1
  else 
    m = valor2 
  end

  if invalido(valor3) then 
    return m
  elseif invalido(m) or avalia( valor3, '>', m ) then
    return valor3
  else 
    return m 
  end
end

function ano( data )
  return tonumber( strsub( data, 7, 10 ))
end

function mes( data )
  return tonumber( strsub( data, 4, 5 ))
end

function dia( data )
  return tonumber( strsub( data, 1, 2 ))
end
 
-- ------------------------------------------------------------------------------
-- Funcoes Especificas para Cronograma
-- ------------------------------------------------------------------------------

function Status( dataei, dataef, datapi, datapf, alerta )
  local seg_sem = 7*24*3600  -- numeros de segundos em uma semana
  local dataei = converte_data( dataei )
  local dataef = converte_data( dataef )
  local datapi = converte_data( datapi )
  local datapf = converte_data( datapf )
  local datahoje = date2sec( date("%d/%m/%Y"), "%d/%m/%Y" )  

  if alerta then alerta = alerta*seg_sem else alerta=0 end

  if (dataei == nil or dataei == '') and datahoje - datapi >= 0 then
       status = 6
  elseif (dataef == nil or dataef == '') and datahoje - datapf > 0 then
       status = 5
  elseif dataei ~= nil and dataei ~= '' and
       (dataef == nil or dataef == '') and datahoje + alerta >= datapf then
       status = 4
  elseif dataei ~= nil and 
       (dataef == nil or dataef == '') and datahoje + alerta < datapf then
       status = 3
  elseif dataef ~= nil then
       status = 2
  elseif datahoje - datapi <= 0 and (dataei == nil or dataei == '') then
       status = 1
  end

  return status
end

function GeraLabels( datamin, datamax )
  local i,a,d,n
  local labels = {}
  local nlabels = 0
  local nome_mes
  local long_names  = { 'jan', 'fev', 'mar', 'abr', 'mai', 'jun',
                  'jul', 'ago', 'set', 'out', 'nov', 'dez' }
  local short_names = { 'J', 'F', 'M', 'A', 'M', 'J',
                  'J', 'A', 'S', 'O', 'N', 'D' }

  i = mes( datamin )
  a = ano( datamin )

  repeat
    if mod( i,13 ) == 0 and i > 12 then 
      i = 1
      a = a + 1 
    end
    nlabels = nlabels + 1
    labels[nlabels] = {}
    labels[nlabels].mesid = mod(i,13)+floor(i/13)
    labels[nlabels].ano = a
    i = i + 1
  until (i > mes( datamax )+1 and a == ano( datamax )) or a > ano( datamax )

  if nlabels > 24 then
    applet_width = applet_width + 5*nlabels
    nome_mes = short_names
  else
    nome_mes = long_names
  end

  write( nlabels ..'\n' )
  i = 1

  while i <= nlabels do
    if i > 1 and labels[i].ano ~= labels[i-1].ano then
      write( '<'..labels[i-1].ano..'>\n')
    end
    write( '"'..nome_mes[labels[i].mesid]..'"\n' )
    write( date2sec( '01/'..labels[i].mesid..'/'..labels[i].ano, "%d/%m/%Y" )..'\n' )
    i = i + 1
  end
  write( '<'..labels[i-1].ano..'>\n')
end

function Tipo( status )
  if status == 6 then
    return 'marca'
  elseif status == 5 then
    return 'atrasado'
  elseif status == 4 then
    return 'alerta'
  elseif status == 3 then
    return 'em andamento'
  elseif status == 2 then
    return 'concluido'
  else
    return 'nada'
  end
end

function GeraArquivoCronograma( dados, controle, titulo, subtitulo, subtitulo2, link, linkframe )

  local datahoje = gsub( date("%Y %m %d"), " ", "" )
  local datamin, datamax
  local index 
  local n = 1 
  local i
  local ordem = {}
  i = 1
  while controle[i] do
    if dados[controle[i]] then
      ordem[n] = {}
      ordem[n].dados = dados[controle[i]]
      ordem[n].nome = controle[i]
      ordem[n].resp = dados[controle[i]].ativ_resp
      ordem[n].ent_resp = dados[controle[i]].ent_resp

      n = n + 1
     
      datamin = min_valor(datamin, dados[controle[i]].dataei, dados[controle[i]].datapi )
      datamax = max_valor( datamax, dados[controle[i]].dataef, dados[controle[i]].datapf )
     
    end

    i = i + 1
  end

  -- n e' agora o numero de fases a serem desenhadas no cronograma
  n = n - 1

  -- ajusta altura do applet
  applet_height = applet_height + 70*n

  local min = formata_data( min_valor( datamin, datahoje ) )
  local max = formata_data( max_valor( datamax, datahoje ) )

  -- titulo
  if titulo then 
     write( '"', titulo, '"\n' ) 
  else 
     write( '""\n' ) 
  end
  
  -- link e frame do titulo
  if link and linkframe then 
    write( '"', link , '"\n' ) 
    write( '"', linkframe , '"\n' )
  else 
    write( '""\n' ) 
  end

  -- subtitulo
  if subtitulo then write( '"', subtitulo, '"\n' ) else write( '""\n' ) end

  -- subtitulo 2
  if subtitulo2 then write( '"', subtitulo2, '"\n' ) else write( '""\n' ) end


  -- label da data de inicio
  if datamin then
     write( '"incio:  ', formata_data( datamin ), '"\n' )
  else
     write( '"incio:  \""\n' )
  end
  

  -- label da data de fim
  if datamax then
     write( '"fim:     ', formata_data( datamax ), '"\n' )
  else
     write('"fim:\"\"\n')
  end

  -- data de inicio em segundos
  write( date2sec( '01/'..mes( min )..'/'..ano( min ), "%d/%m/%Y" )..'\n' )

  -- data de hoje em segundos
  write( valor( converte_data( datahoje ))..'\n' )

  -- data de fim em segundos
  local m = mes( max ) + 1
  local a = ano( max )
  if mod( m,13 ) == 0 and m > 12 then 
    m = 1
    a = a + 1 
  end
  write( date2sec( '01/'..m..'/'..a, "%d/%m/%Y" )..'\n' )

  -- numero de fases
  write( n ..'\n' )
  

-- ----------------------
-- Monta o cronograma 
-- ----------------------

  i = 1

  while ordem[i] do

    write( '"'..ordem[i].nome..'"\n' )
    andamento=Tipo( ordem[i].dados.status )
    write('""\n')
    write( '"http://'..getenv("SERVER_NAME")..cgilua.mkurl( '../'..cgi.pagina, 
          { cod = cgi.proj_cod, tipo_servico = cgi.tipo_servico, cons_cod = cgi.cons_cod } )..
           '"\n"princ"\n' )

    --DATA Prevista inicial      
    data = valor( converte_data( ordem[i].dados.datapi ))
    write( data ..'\n'  )
    if ordem[i].dados.datapi == "NAO_CONHECIDA" or not ordem[i].dados.datapi or ordem[i].dados.datapi == '' then
       dta_de_hoje = date("%Y%m%d")
       dta_mes = strsub(dta_de_hoje, 5, 6)
       dta_dia = strsub(dta_de_hoje, 7, 8)
    else
       dta_mes = strsub(ordem[i].dados.datapi, 5, 6)
       dta_dia = strsub(ordem[i].dados.datapi, 7, 8)
    end
    write( '"' .. dta_dia .. '/' .. dta_mes .. '"\n')
    
    --DATA Prevista Final      
    if ordem[i].dados.datapf == "NAO_CONHECIDA" or not ordem[i].dados.datapf or ordem[i].dados.datapf == ''then
       dta_de_hojehoje = date("%Y%m%d")
       dta_mes = strsub(dta_de_hoje_hoje, 5, 6)
       dta_dia = strsub(dta_de_hoje, 7, 8)
    else
       dta_mes = strsub(ordem[i].dados.datapf, 5, 6)
       dta_dia = strsub(ordem[i].dados.datapf, 7, 8)
    end
    -- Se data final for igual a inicial incrementa de um a final para aparecer no cronograma
    if ordem[i].dados.datapf==ordem[i].dados.datapi and ordem[i].dados.datapf and ordem[i].dados.datapf ~= '' then 
       ordem[i].dados.datapf=IncrementaData(ordem[i].dados.datapf) 
    end
    data = valor( converte_data( ordem[i].dados.datapf ))
    write( data ..'\n' )
    write( '"' .. dta_dia .. '/' .. dta_mes .. '"\n')
    
    --DATA Esperada Inicial
    data = valor( converte_data( ordem[i].dados.dataei ))    
    write( data ..'\n'  )

    if ordem[i].dados.dataei == "NAO_CONHECIDA" or not ordem[i].dados.dataei or ordem[i].dados.dataei == ''then
       dta_de_hoje = date("%Y%m%d")
       dta_mes = strsub(dta_de_hoje, 5, 6)
       dta_dia = strsub(dta_de_hoje, 7, 8)
    else
       dta_mes = strsub(ordem[i].dados.dataei, 5, 6)
       dta_dia = strsub(ordem[i].dados.dataei, 7, 8)
    end
    write( '"' .. dta_dia .. '/' .. dta_mes .. '"\n')
    
    --DATA Esperada Final

    if ordem[i].dados.dataef == "NAO_CONHECIDA"  or not ordem[i].dados.dataef or ordem[i].dados.dataef == ''then
       dta_de_hoje = date("%Y%m%d")
       dta_mes = strsub(dta_de_hoje, 5, 6)
       dta_dia = strsub(dta_de_hoje, 7, 8)
    else
       dta_mes = strsub(ordem[i].dados.dataef, 5, 6)
       dta_dia = strsub(ordem[i].dados.dataef, 7, 8)
    end
    -- Se data final for igual a inicial incrementa de um a final para aparecer no cronograma
    if ordem[i].dados.dataef==ordem[i].dados.dataei and ordem[i].dados.dataef and ordem[i].dados.dataef ~= '' then 
       ordem[i].dados.dataef=IncrementaData(ordem[i].dados.dataef) 
    end
    data = valor( converte_data( ordem[i].dados.dataef ))
    write(data  ..'\n' )
    write( '"' .. dta_dia .. '/' .. dta_mes .. '"\n')
    
    --link do cronograma de barras para cronograma do projeto   
    write( '"http://'..getenv("SERVER_NAME")..cgilua.mkurl( '../'..cgi.pagina,
           {cod = cgi.proj_cod, tipo_servico = cgi.tipo_servico,cons_cod=cgi.cons_cod } )..'"\n' )
    write( '"princ"\n' )
    write( '"'..Tipo( ordem[i].dados.status )..'"\n' )

    i = i + 1
  end

  GeraLabels( min, max )
end 