-- --------------------------------------------------------------------------------
-- CONSTANTES.LUA
-- --------------------------------------------------------------------------------

-- --------------------------------------------------------------------------------
-- Datas PEGASO
-- --------------------------------------------------------------------------------
   _NUM_ANOS_PEGASO_ = 11
   _ANO_INI_PEGASO_  = 2000
   _ANO_FIM_PEGASO_  = 2010
   
   _ANO_INI_CUSTO_PEGASO_  = 2000
   _ANO_FIM_CUSTO_PEGASO_  = 2003

   _DATA_INI_PEGASO_      = '20000401'
   _DATA_INI_PEGASO_DESC_ = 'primeiro de abril de 2000'
   _DATA_FIM_PEGASO_      = '20101231'
   _DATA_FIM_PEGASO_DESC_ = 'trinta e um de dezembro de 2010'
   
   _DATA_INI_PREV_PEGASO_ = '01/04/2000'
   _DATA_FIM_PREV_PEGASO_ = '31/12/2010'

-- --------------------------------------------------------------------------------
-- Figuras relacionadas ao STATUS/DESEMPENHO dos projetos e seus textos descritivos
-- --------------------------------------------------------------------------------
   _IMG_EDICAO_                    = 'imagens/bol_edicao2.gif'
   _DESCR_IMG_EDICAO_              = 'Projeto no iniciado'
   _IMG_CONCLUIDO_                 = 'imagens/bol_concluido2.gif'
   _DESCR_IMG_CONCLUIDO_           = 'Projeto concludo'
   _IMG_CANCELADO_                 = 'imagens/bol_cancelado2.gif'
   _DESCR_IMG_CANCELADO_           = 'Projeto cancelado'
   _IMG_DESEMPENHO_PREVISTO_       = 'imagens/bol_desemp_acordo2.gif'
   _DESCR_IMG_DESEMPENHO_PREVISTO_ = 'Projeto de acordo com o previsto'
   _IMG_DESEMPENHO_NEGATIVO_       = 'imagens/bol_desemp_abaixo2.gif'
   _DESCR_IMG_DESEMPENHO_NEGATIVO_ = 'Projeto abaixo do previsto'
   _IMG_DESEMPENHO_POSITIVO_       = 'imagens/bol_desemp_acima2.gif'
   _DESCR_IMG_DESEMPENHO_POSITIVO_ = 'Projeto acima do previsto'
           

-- --------------------------------------------------------------------------------
-- Esse valor diz respeito ao tamanho do campo no banco relacionado as tabelas
-- lista_personalizada e lista_relat_personalizado referente a lista de cdigos de
-- projeto, que eh um TEXT de 16 (ateh 900 caracteres fica visivel no banco, depois 
-- disso continua visivel para o LUA mas passa para <long text> no banco
-- --------------------------------------------------------------------------------
   _TAM_CAMPO_LISTA_ = 900
   
-- --------------------------------------------------------------------------------
-- Esse valor diz respeito ao tamanho limite do CGI passado por parametro     
-- --------------------------------------------------------------------------------
   _TAM_CGI_ = 900   
   
-- --------------------------------------------------------------------------------
-- Endereco do servidor de e-mail do TECGRAF
-- --------------------------------------------------------------------------------
-- _MAILSERVER_='139.82.85.1'
   _MAILSERVER_ = "mail.tecgraf.puc-rio.br" 

-- --------------------------------------------------------------------------------
-- Extensao de e-mail do TECGRAF
-- --------------------------------------------------------------------------------
   _MAIL_='@tecgraf.puc-rio.br'

-- --------------------------------------------------------------------------------
-- Endereo do servidor de e-mail da PETROBRAS                
-- --------------------------------------------------------------------------------
-- Servidor de e-mail da PETROBRAS < 164.85.62.165 >
-- _MAILSERVER_ = "164.85.62.165" 

-- --------------------------------------------------------------------------------
-- Extensao de e-mail da PETROBRAS
-- --------------------------------------------------------------------------------
-- _MAIL_='@petrobras.com.br'

-- --------------------------------------------------------------------------------
-- Chaves do Coordenador Corporativo e do Grupo Gestao Pegaso -- usado no TECGRAF
-- Chave do usuario em nome de quem serao enviados os e-mails (jah que o grupo de 
-- gestao pode ter mais de uma chave)
-- --------------------------------------------------------------------------------
   _CHAVE_COORDENADOR_PEGASO_ = 'CECILIAK'
   _CHAVES_GESTAO_PEGASO_     = {                                                                   
                                  CECILIAK = 1,
                                  CIESLAK  = 1,
                                  VALCS    = 1,
                                  SMARINHO = 1
                                }
   _CHAVE_RESP_GESTAO_PEGASO_ = 'CECILIAK'


-- --------------------------------------------------------------------------------   
-- Garante acesso completo aos projetos de todos os orgaos (AN) e unidades (UN) 
-- nas consultas e relatorios
-- Renata Sibilo (esi0), TeCGraf(tecg) e o Grupo Gesto Pegaso (PWHC) continuam tendo 
-- acesso a TODAS as informaes. 
-- --------------------------------------------------------------------------------   
   _CHAVES_ACESSO_COMPLETO_ = {  
                                 ESI0    = 1,
                                 PWHC    = 1,
                                 SMG9	 = 1,
                                 TE83    = 1,
                                 EU50    = 1,
                                 BI27    = 1,
                                 BB42    = 1,
                                 BD48    = 1,
                                 ESD9    = 1,
                                 ZNJM    = 1,
                                 ZNB5    = 1,
                                 DU58    = 1,
                                 ZNE1    = 1,
                                 F026    = 1,
                                 EUTG    = 1,
                                 CIESLAK = 1,
                                 VALCS   = 1,
                                 SMARINHO= 1,
                                 CECILIAK= 1,
                                 CASSINO= 1,
                              }

-- --------------------------------------------------------------------------------
-- Chaves do Coordenador Corporativo e do Grupo Gestao Pegaso (usado na PETROBRAS)
-- Chave do usuario em nome de quem serao enviados os e-mails (jah que o grupo de 
-- gestao pode ter mais de uma chave)
-- --------------------------------------------------------------------------------
-- Coordenador     -> pes_chave: te83    pes_email: jseta@petrobras.com.br 
-- Gestao          -> pes_chave: PWHC    pes_email: gestao.pegaso@petrobras.com.br
-- Gestao (origem) -> pes_chave: PWHC    pes_email: gestao.pegaso@petrobras.com.br
-- --------------------------------------------------------------------------------
--   _CHAVE_COORDENADOR_PEGASO_ = 'te83'
--   _CHAVES_GESTAO_PEGASO_     = {
--                                  PWHC = 1
--                                }
--   _CHAVE_RESP_GESTAO_PEGASO_ = 'PWHC'

-- --------------------------------------------------------------------------------   
-- Chave do Coordenador do PROGRAMA EMERGENCIAL DE INTEGRIDADE DE DUTOS  
-- Chaves do Grupo Gestao do PROGRAMA EMERGENCIAL DE INTEGRIDADE DE DUTOS
-- Chave do usuario em nome de quem serao enviados os e-mails (jah que o grupo de 
-- gestao pode ter mais de uma chave)
-- --------------------------------------------------------------------------------
-- Coordenador -> pes_chave: ''    pes_email: '' (provisoriamente sem coordenador)
-- Gestao          -> pes_chave: y304     pes_email: ''
-- Gestao (origem) -> pes_chave: y304     pes_email: ''
-- --------------------------------------------------------------------------------
   _CHAVE_COORDENADOR_PAEID_ = ''
--   _CHAVES_GESTAO_PAEID_     = {
--                                 y304 = 1
--                               }
--   _CHAVE_RESP_GESTAO_PAEID_ = 'y304'
   _CHAVES_GESTAO_PAEID_     = {
                                  cieslak  = 1,
                                  ceciliak = 1
                               }
   _CHAVE_RESP_GESTAO_PAEID_ = 'ceciliak'

-- --------------------------------------------------------------------------------   
-- Chave da origem dos Projetos Classe I (PWHC)   
-- Origem      -> pes_chave: PWHC     pes_email: gestao.pegaso@petrobras.com.br
-- --------------------------------------------------------------------------------
--   _CHAVE_PROJ_CLASSE_I_ = 'PWHC'
   _CHAVE_PROJ_CLASSE_I_ = 'ceciliak'

-- --------------------------------------------------------------------------------
-- Chamada da funo de envio de E-mail
-- Parametros: para, de, assunto, msg, copia
-- --------------------------------------------------------------------------------
--   function ENVIA_EMAIL(destino, origem, titulo, mensagem, copia)
--      return envia_mail(destino, origem, titulo, mensagem, copia)
--   end
   function ENVIA_EMAIL(destino, origem, titulo, mensagem, copia)
      return envia_mail(getuser().._MAIL_, getuser().._MAIL_, titulo, mensagem, getuser().._MAIL_)
   end

-- --------------------------------------------------------------------------------
-- Mensagens de erro referente as datas das atividades realizadas para o 
-- acompanhamento de projeto
-- --------------------------------------------------------------------------------   
   msg_dt_ini_real = {}
   msg_dt_ini_real[1] = '<P CLASS=msgErro>A Data de Incio Real da atividade no pode ser posterior a Data de Trmino Real da atividade. Altere uma das datas.</P>'
   msg_dt_ini_real[2] = '<P CLASS=msgErro>A Data de Incio Real no pode ser posterior a data de hoje.</P>'
   msg_dt_ini_real[3] = '<P CLASS=msgErro><I>A Data de Incio Real deve ser preenchida.</P>'
   msg_dt_ini_real[4] = '<P CLASS = msgErro><I>A Data de Incio Real do Projeto deve ser preenchida.</P>'
   msg_dt_ini_real[5] = '<P CLASS = msgErro><I>A Data de Incio Real da Atividade deve ser igual ou posterior a data de Incio do Projeto.</P>'
   msg_dt_ini_real[6] = '<P CLASS = msgErro><I>A Data de Incio Real da Atividade deve ser anterior ou igual a data de Fim do Projeto.</P>'

   msg_dt_fim_real = {}
   msg_dt_fim_real[1] = '<P CLASS=msgErro><I>A Data de Fim Real no pode ser posterior a data de hoje.</P>'
   msg_dt_fim_real[2] = '<P CLASS = msgErro><I>A Data de Fim Real da Atividade deve ser igual ou anterior a data de Fim do Projeto.</P>'
