-- -------------------------------------------------------------------------------------------
-- FORM_ATIVIDADES.LUA
-- -------------------------------------------------------------------------------------------
cgi.descricao_ativ = gsub(cgi.descricao_ativ,"'",'"')


--------------------------------------------------------------------------------------------------------
-- As variaveis _DATA_FIM_PEGASO_DESC_, _DATA_INI_PEGASO_DESC_, _DATA_INI_PEGASO_ e _DATA_FIM_PEGASO_ --
--estao contidas em constantes.lua.                                                                   --
--------------------------------------------------------------------------------------------------------
form_atividades = Formulario:new 
{{
      CampoCaracter:new { 'descrio', "descricao_ativ","sim", nil, nil, cgi.descricao_ativ}, 

	    CampoData:new 
       {
          'Data prevista para o Inicio', 'dt_ini_prevista_ativ', 'sim',
          { 
             limite = 
             { 
                ['>='] = 
                { 
                   nome = _DATA_INI_PEGASO_DESC_ , valor = _DATA_INI_PEGASO_
                },

                ['<='] = 
                { 
                   nome = _DATA_FIM_PEGASO_DESC_ , valor = _DATA_FIM_PEGASO_ 
                } 
             } 
          }, nil, 
	       cgi.dt_ini_prevista_ativ, "texto" 
	    }, 

            
	    CampoData:new 
       {
          'Data prevista para o fim', 'dt_fim_prevista_ativ', 'sim',
          { 
             limite = 
             { 
                ['>='] = 
                { 
                   nome = _DATA_INI_PEGASO_DESC_ , valor = _DATA_INI_PEGASO_
                },

                ['<='] = 
                { 
                   nome = _DATA_FIM_PEGASO_DESC_ , valor = _DATA_FIM_PEGASO_
                }
             } 
          }, nil, 
	       cgi.dt_fim_prevista_ativ, "texto" 
	    }, 

	    CampoData:new 
       {
          'Data prevista para o Trmino do Projeto', 'proj_dt_fim_prev', nil,
          { 
             limite = 
             { 
                ['>='] = 
                { 
                   nome = _DATA_INI_PEGASO_DESC_ , valor = _DATA_INI_PEGASO_
                },

                ['<='] = 
                { 
                   nome = _DATA_FIM_PEGASO_DESC_ , valor = _DATA_FIM_PEGASO_ 
                } 
             } 
          }, nil, 
	       cgi.proj_dt_fim_prev, "texto" 
	    }, 
	    
	   CampoInteiro:new 
	   {
	      'Alerta', 'alerta', 'sim', 
	      {
	         limite = 
             { 
                ['>='] = 
                { 
                   nome = '0', valor = 0 
                },                                                
             }
          }, nil, cgi.alerta 
	    },
	   
	   CampoInteiro:new 
	   {
	      'Peso', 'peso', 'sim', 
	      {
	         limite = 
             { 
                ['>'] = 
                { 
                   nome = '0', valor = 0
                },

                ['<='] = 
                { 
                   nome = '100', valor = 100 
                } 
             }
          }, nil, cgi.peso 
        },
	   
}}	
