-- ----------------------------------------------------------------------------------------------------------------
-- FORMALIZA.LUA
-- ----------------------------------------------------------------------------------------------------------------
if cgi.acao == 'Formaliza' then 
   dofile ( 'acessabd.lua' )
   dofile ( 'global.lua' )
   dofile ( 'mail.lua' )

   -- Retorna o codigo do responsavel(usuario corrente) pela formalizacao.
   resp_form = retornaPessoaCod(getuser())
   
   -- Retorna a data atual
   dataform = DataAtual()

   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end

   AlteraBD( "projeto", " stat_cod = 2, proj_resp_form = "..resp_form..", proj_dt_form = '"..dataform.."'", " proj_cod = "..cgi.cod.."")
      
   -- ---------------------------------------------------------------------------------------         
   -- Atualizao da tabela de FOLLOW_UP quando o projeto eh FORMALIZADO
   -- ---------------------------------------------------------------------------------------                                       
   atualizaFollowUp(cgi.cod,1,'Formalizao do projeto.')

   -- ---------------------------------------------------------------------------------------
   -- Chama a funcao EMAIL da pagina MAIL.LUA para enviar os e-mails aos responsaveis.
   -- Redireciona as mensagens obtidas da funcao EMAIL
   -- ---------------------------------------------------------------------------------------         
   msgsuc, email = email(cgi.cod, 'formaliza') 
   
   -- ---------------------------------------------------------------------------------------       
   -- Redireciona para a funcao que chamou a acao de formalizacao: EDICAO ou FORMALIZACAO
   -- ---------------------------------------------------------------------------------------               
   cgilua.redirect('../visualiza.html?'..cgilua.encodetable( { tipo_servico = cgi.tipo_servico, tipo_edi = cgi.tipo_edi, cond_filtro = cgi.cond_filtro, msgsuc = msgsuc, email = email } )) -- VOLTA PARA A PAGINA de visualizacao
end