dofile( 'lua/acessabd.lua' )
dofile( 'lua/global.lua' )
dofile( 'lua/desempenho.lua' )

-- ----------------------------------------------------------------------------
-- function : val
-- description : converte valor em um numero
-- parameters : sVal : valor a ser convertido
-- return: numero , 0 se sVal for nil
-- ----------------------------------------------------------------------------
function val(sVal)
   local aux = tonumber(sVal)
   if aux then
   	return(aux)
   end
   return(0)
end  

-- ----------------------------------------------------------------------------
-- Retorna os campos da tabela ATIVIDADE
-- ----------------------------------------------------------------------------
function retornaAtividadesProj( cod )
   local result = {}
   result = ConsultaBD2( "atividade", "ativ_cod, ativ_nome, ativ_dt_ini_prev, ativ_dt_fim_prev," ..
   "ativ_dt_ini_real, ativ_dt_fim_real, ativ_peso_rel_proj, ativ_perc_real",
   "proj_cod = " .. cod, "ativ_dt_ini_prev, ativ_nome" )
   return result
end


function mostraAtividadesProjAcom( cod )
   local i,j
   local result = {}
   local total_perc_proj = 0
   i = 1
   
   write ( '\n<SCRIPT LANGUAGE="JavaScript">' )
   write ( 'function Verifica(i)\n')
   write ( '{\n' )
   write ( 'data1 = eval("document.form1.dt_ini_real"+i+".value");\n' )
   write ( 'data2 = eval("document.form1.dt_fim_real"+i+".value");\n' )
   write ( '//percentual = eval("document.form1.perc_real"+i+".value");\n')
   write ( 'if (data1 != "" && data2 != ""){\n' )
   write ( 'x  = eval("document.form1.perc_real"+i);\n')
   write ( 'x .value = "100";\n')
   write ( '}}\n')
   write ( '</SCRIPT>\n' )
   write( '<BR><HR WIDTH="85%">\n')
   
   result = retornaAtividadesProj( cod )
   if ( result[i] and result[i].ativ_cod) then
         write( '<TABLE WIDTH="90%" BORDER="0" ALIGN="CENTER">\n')
         write( '<TR><TD>&nbsp;&nbsp;</TD><TD align="center" class=fieldLabel><b>Atividades</b></TD></TR>\n' )
         write( '<TR>\n' )
         write( '<TD>&nbsp;&nbsp;</TD>\n' )        
         write( '<TD>\n' )
            write( '<TABLE WIDTH="100%" BORDER="1" ALIGN="CENTER">\n')           
            write( '<TR>\n' )
            write( '<TD><B>Nome da Atividade</B></TD>\n' )
            write( '<TD><B>Data de Incio Previsto</B></TD>\n' )
            write( '<TD><B>Data de Fim Previsto</B></TD>\n' )
            write( '<TD><B>Peso Relativo</B></TD>\n' )
            write( '<TD><B><A HREF=Javascript:window.top.abre_hint("hint_Data_de_Inicio_Real_da_Atividade_Acompanhamento_de_Projeto__")><font color=black>Data de Incio Real (dd/mm/aaaa)</font></a></B></TD>\n' )
            write( '<TD><B><A HREF=Javascript:window.top.abre_hint("hint_Data_de_Fim_Real_da_Atividade_Acompanhamento_de_Projeto__")><font color=black>Data de Fim Real (dd/mm/aaaa) </font></a></B></TD>\n' )
            write( '<TD CLASS="rotulo"><A HREF=Javascript:window.top.abre_hint("hint_Realizacao_Fisica_Acompanhamento_de_Projeto__")><font color=black><B>Realizao Fsica </B></font></a></TD>\n' )
            write( '<TD><B>Dependncia</B></TD>\n' )
            write( '</TR>\n' )
         
      while ( result[i] ) do
         if result[i].ativ_perc_real ~= nil and result[i].ativ_perc_real ~= "" then
            total_perc_proj = total_perc_proj + result[i].ativ_perc_real
         end
         
         -- Escreve os ttulos
         write( '<TR>\n' )      
         write( '<TD align="center">' .. result[i].ativ_nome .. '</TD>\n' )
         write( '<TD align="center">' .. formataData2(result[i].ativ_dt_ini_prev) .. '</TD>\n' )
         write( '<TD align="center">' .. formataData2(result[i].ativ_dt_fim_prev) .. '</TD>\n' )
         write( '<TD align="center">' .. result[i].ativ_peso_rel_proj)
         write('<INPUT TYPE="hidden" NAME="peso_rel_proj'..i..'" VALUE="'..formataData(result[i].ativ_peso_rel_proj)..'"> </TD>\n')
         
         -- CAMPO DATA DE INICIO REALIZADA
         
         if not result[i].ativ_dt_ini_real or result[i].ativ_dt_ini_real == '' then
            result[i].ativ_dt_ini_real = ''
         end
         
         local valor = ''
         
         if cgi['dt_ini_real'..i] then
            valor = cgi['dt_ini_real'..i]
         else
            valor = formataData2(result[i].ativ_dt_ini_real)
         end
         write( '<TD align="center"><INPUT SIZE="8" MAXLENGTH="10" TYPE="TEXT" NAME="dt_ini_real'..i..'" VALUE="' ..valor..'" ONCHANGE="javascript:MudaTab('..i..')");">\n' )          
         
         if cgi['msg_dt_ini_real'..i] then  
            write(cgi['msg_dt_ini_real'..i])
            cgi['msg_dt_ini_real'..i] = ''
         end
         write('</TD>\n')
               	
         -- CAMPO DATA DE TERMINO REALIZADA
         
         if not result[i].ativ_dt_fim_real or result[i].ativ_dt_fim_real == '' then
            result[i].ativ_dt_fim_real = ''
         end
         
         if cgi['dt_fim_real'..i] then
            valor = cgi['dt_fim_real'..i]
         else
            valor = formataData2(result[i].ativ_dt_fim_real)
         end
         write( '<TD align="center"><INPUT SIZE="8" MAXLENGTH="10" TYPE="TEXT" NAME="dt_fim_real'..i..'" VALUE="'..valor..'" ONCHANGE="javascript:MudaTab('..i..')");">\n' )         
         
         if cgi['msg_dt_fim_real'..i] then
            write(cgi['msg_dt_fim_real'..i])
            cgi['msg_dt_fim_real'..i] = ''
         end
         write('</TD>\n')
         
         -- percentual real eh sobre o peso
         if cgi['perc_real'..i] then       
            valor = cgi['perc_real'..i]
         else
            if result[i].ativ_perc_real then
               valor = formata_percentual(tostring(val(result[i].ativ_perc_real)/val(result[i].ativ_peso_rel_proj)*100))
            else
               valor = ''
            end
         end
         write( '<TD align="center"><INPUT SIZE="5" MAXLENGTH="3" TYPE="TEXT" NAME="perc_real'..i.. '" VALUE="' ..valor.. '" ONCHANGE="javascript:MudaTab('..i..')");">\n' )
         
         if cgi['msg_perc_real'..i] then  
            write(cgi['msg_perc_real'..i])
            cgi['msg_perc_real'..i] = ''
         end
         write('</TD>\n')
         
         select = "SELECT dep_area_cod, area_nome FROM dependencia, areas WHERE dep_area_cod = area_cod AND dep_ativ_cod = "..result[i].ativ_cod
         AbreBD()
         DBExec(select)
         resultado = DBRow()
         if resultado and temConteudo(resultado.area_nome) then
            if resultado and (resultado.dep_area_cod == 5 or resultado.dep_area_cod == 6) then
               write ( '<TD ALIGN="center"><A HREF="javascript:mostra_desc(',result[i].ativ_cod,')";>', resultado.area_nome, '</A></TD>\n' )
            else
               write ( '<TD ALIGN="center">', resultado.area_nome, '</TD>\n' )
            end
         else
            write ( '<TD ALIGN="center">-</TD>\n' )
         end
         
         if cgi['msg_perc_real'..i] then
            write(cgi['msg_perc_real'..i]..'</TD>\n')
         else
            write('</TD>\n')
         end         	                 	         
         write( '</TR>\n' )
         write('<INPUT TYPE="hidden" NAME="ativ_cod'..i..'" VALUE="'..result[i].ativ_cod..'">\n')
         i = i + 1
      end      
   
      write( '</TABLE>\n' )
      write( '</TD>\n' )
      write( '</TR>\n' )
      write( '</TABLE>\n' )      
      write( '<TR><TD>&nbsp;</TD></TR></TABLE>' )
      write( '<TABLE BORDER="0" ALIGN="CENTER"><TR><TD><B>Realizao Total Fsica:</B></TD><TD>' ,formata_valor(total_perc_proj), '%</TD></TR>\n')
      write( '</TABLE><BR>\n' )    
   else
      write( '<BR><FONT CLASS=fieldLabel>No h atividades cadastradas para esse projeto!</FONT><BR><BR>\n' )
   end
   
   write( '<HR WIDTH="85%"><BR>\n' )
  
   cgi.cont = i
   write('<INPUT TYPE="hidden" NAME="cont" VALUE="'..cgi.cont..'">\n')
end


-- Funo para visualizar atividades do projeto 
function mostraAtividadesProjVisual( cod )
   local i,j
   local result = {}
   
   result = retornaAtividadesProj( cod )
   i = 1
   if ( result[i].ativ_cod and result[i].ativ_cod ~= '') then
      write( '<HR WIDTH="85%">\n' )
      write( '<TABLE WIDTH="95%" BORDER="0" ALIGN="CENTER">\n')      
      write( '<TR><TD align="center" colspan="9" class=fieldLabel><b>Atividades</b></TD></TR>\n' )
      write( '<TR VALIGN="bottom">\n' )
      write( '<TD align="left"><B>Nome</B></TD>\n' )
      write( '<TD align="center"><B>Incio Previsto</B></TD>\n' )
      write( '<TD align="center"><B>Fim Previsto</B></TD>\n' )
      write( '<TD align="center"><B>Incio Real</B></TD>\n' )
      write( '<TD align="center"><B>Fim Real</B></TD>\n' )
      write( '<TD align="center"><B>Peso</B></TD>\n' )
      write( '<TD width="80"><font size="1"><b>%Realizado<br>(%Esperado)</b></font></TD>\n')
      write( '<TD width="80"><font size="1"><b>%Realizado<br>no Projeto<br>(%Esperado)</b></font></TD>\n')
      write( '<TD align="center"><B>Dependncia</B></TD>\n' )
      write( '</TR>\n' ) 

      total_perc_proj = 0
      local hoje = date("%Y%m%d")
      while ( result[i]) do
         if mod(i, 2) == 1 then       
            write( '<TR BGCOLOR=#ECECEC>\n' )
         else
            write( '<TR BGCOLOR=#CCCCCC>\n' )
         end
         write('<INPUT TYPE="hidden" NAME="ativ_nome'..i..'" VALUE="'..result[i].ativ_nome..'">\n')
         write( '<TD align="left">' .. result[i].ativ_nome .. '</TD>\n' )
        
         write('<INPUT TYPE="hidden" NAME="ativ_dt_ini_prev'..i..'" VALUE="'..formataData(result[i].ativ_dt_ini_prev)..'">\n')
         write( '<TD align="center">' .. formataData2(result[i].ativ_dt_ini_prev).. '</TD>\n' )
      
         write('<INPUT TYPE="hidden" NAME="ativ_dt_fim_prev'..i..'" VALUE="'..formataData(result[i].ativ_dt_fim_prev)..'">\n')
         write( '<TD align="center">' .. formataData2(result[i].ativ_dt_fim_prev).. '</TD>\n' )
       
         if not result[i].ativ_dt_ini_real then
            result[i].ativ_dt_ini_real = ''
         end
         write('<INPUT TYPE="hidden" NAME="ativ_dt_ini_real'..i..'" VALUE="'..formataData2(result[i].ativ_dt_ini_real)..'">\n')
         if result[i].ativ_dt_ini_real and result[i].ativ_dt_ini_real ~= '' then
            write( '<TD align="center">' .. formataData2(result[i].ativ_dt_ini_real) .. '</TD>\n' )
         else 
            write( '<TD align="center">&nbsp;</TD>\n' )
         end
         if not result[i].ativ_dt_fim_real then
            result[i].ativ_dt_fim_real = ''
         end
         write('<INPUT TYPE="hidden" NAME="ativ_dt_fim_real'..i..'" VALUE="'..formataData2(result[i].ativ_dt_fim_real)..'">\n')
         if result[i].ativ_dt_fim_real and result[i].ativ_dt_fim_real ~= '' then
            write( '<TD align="center">' .. formataData2(result[i].ativ_dt_fim_real) .. '</TD>\n' )
         else
            write( '<TD align="center">&nbsp;</TD>\n' )
         end
         
         write('<INPUT TYPE="hidden" NAME="ativ_peso_rel_proj'..i..'" VALUE="'..formataData(result[i].ativ_peso_rel_proj)..'">\n')
         write( '<TD align="center">' .. formataData(result[i].ativ_peso_rel_proj) .. '</TD>\n' )      
         
         AbreBD()
         DBExec("select tipo_curva from orgao, projeto "..
                "where orgao.org_cod=projeto.org_cod"..
                "      and projeto.proj_cod="..cod)
                
         local tipo_curva = DBRow().tipo_curva
         local peso = tonumber(result[i].ativ_peso_rel_proj) / 100
         local realizado = (result[i].ativ_perc_real or 0) / peso
         local planejado = planejadoCurvaS(tipo_curva,
                                           result[i].ativ_dt_ini_prev,
                                           result[i].ativ_dt_fim_prev,
                                           hoje)
         write('<TD width="80">', formata_valor(realizado), '% (',formata_valor(planejado), '%)</TD>\n')
         write('<TD width="80">', formata_valor(realizado * peso), '% (',formata_valor(planejado * peso), '%)</TD>\n')
         write('<INPUT TYPE="hidden" NAME="ativ_perc_real'..i..'" VALUE="'..
                 tostring(val(result[i].ativ_perc_real) / val(result[i].ativ_peso_rel_proj)*100)..'">\n')

         select = "SELECT dep_area_cod, area_nome FROM dependencia, areas WHERE dep_area_cod = area_cod AND dep_ativ_cod = "..tonumber(result[i].ativ_cod)     
         DBExec(select)
         resultado = DBRow()

         if resultado and (resultado.dep_area_cod == 5 or resultado.dep_area_cod == 6) then
            write ( '<TD ALIGN="center"><A HREF="javascript:mostra_desc('..result[i].ativ_cod..')";>', resultado.area_nome, '</A></TD>\n' )
         elseif resultado then
            write ( '<TD ALIGN="center">', resultado.area_nome, '</A></TD>\n' )
         else
            write ( '<TD ALIGN="center">-</TD>\n' )
         end
         if result[i].ativ_perc_real and result[i].ativ_perc_real ~= "" then
            total_perc_proj = total_perc_proj + result[i].ativ_perc_real
         end
                        	         
         write( '</TR>\n' )
         i = i + 1
      end      
      write('</TABLE><TABLE WIDTH="80%" BORDER="0" ALIGN="CENTER"><TR><TD>&nbsp;</TD></TR>\n')
      write('<TR><TD ALIGN="center"><B>Percentual Total Realizado: </B>',formata_valor(total_perc_proj),'%</TD></TR>\n')
      write( '</TABLE><BR>\n' )    
      write( '<HR WIDTH="85%">\n' )
      
   else
      write( '<HR WIDTH="85%"><TABLE WIDTH="100%"><TR><TD ALIGN=CENTER CLASS=fieldLabel>No h atividades cadastradas para esse projeto!</TD></TR></TABLE><HR WIDTH="85%">' )
   end
end