dofile( 'desempenho.lua' )

cgi.tipo_servico      = 'relatorio'
cgi.campo_status      = '1'
cgi.campo_desempenho  = '1'
cgi.campo_informacoes = '1'

-- ------------------------------------------------------------------------------------------------------------------
-- RELAT_OUTRO.LUA
-- ------------------------------------------------------------------------------------------------------------------
   if ( cgi.acao == "Limpa Campos" ) then
      -- cgilua.redirect("../relat_outro.html")
       cgilua.redirect("../filtro_projetos.html")
       exit()
   end

-- ------------------------------------------------------------------------------------------------------------------
-- CARREGA A BIBLIOTECA VALIDAFORM 
-- ------------------------------------------------------------------------------------------------------------------
   dofile("../validaform/validaform.lua")
   dofile("form_cons_outras.lua")
 
   cgi.msg = form_cons_outras:critica()

-- ------------------------------------------------------------------------------------------------------------------
-- HOUVE ERRO NO PREENCHIMENTO
-- ------------------------------------------------------------------------------------------------------------------
if ( cgi.msg ) then
   --cgilua.redirect('../relat_outro.html?'..cgilua.encodecgi()) -- VOLTA PARA A PGINA html
   cgilua.redirect('../filtro_projetos.html?'..cgilua.encodecgi()) -- VOLTA PARA A PGINA html
   
elseif ( ( cgi.acao == "Consulta" ) or ( cgi.acao == "Grava Consulta" ) ) then
   cgilua.htmlheader()
   write('<HTML>\n')
   write('<HEAD>\n')
   write('<LINK REL="stylesheet" HREF="../pegaso.css" TYPE="text/css">\n')
   write('<TITLE>Resultado do Relatrio</TITLE>\n')
    
   write('<SCRIPT LANGUAGE="JavaScript">\n')
   write('var selecionado = null;\n')  
   write('function Over(nome)\n')
   write('{\n')
   write('   if (selecionado != null)\n')
   write('   {\n')
   write('      Out(selecionado);\n')
   write('   }\n')
   write('   document[nome].src="../imagens/" + nome + "2.gif";\n')
   write('}\n')
   write('function Out(nome)\n')
   write('{\n')
   write('   if (nome != selecionado)\n')
   write('   {\n')
   write('      document[nome].src="../imagens/" + nome + ".gif";\n')
   write('   }\n')
   write('}\n')
   write('</SCRIPT>\n') 
     
   write('</HEAD>\n')
   write('<BODY BACKGROUND="../imagens/moldura_princ.gif">\n')
   write('<FORM NAME="form1" ACTION="relat_outro3.lua">\n')
   write('\n')

   if ( cgi.acao == "Grava Consulta" ) then
      dofile( 'grava_cons_perso.lua' )
      cons_gravada = grava_cons_perso()
   end
   campo, valor = next( cgi, nil )
   while campo do
      if ( campo ~= 'nome_cons_perso' ) then
         write('<INPUT TYPE="HIDDEN" NAME="' .. campo .. '" VALUE="' .. valor .. '">\n')
      end
      campo, valor = next( cgi, campo )
   end

   dofile( 'projetos.lua' )
   dofile( 'global.lua' )
   dofile( 'constantes.lua' )
   dofile( 'cores.lua' )    
   dofile( 'acessabd.lua' )
   dofile( 'permissao_acesso.lua' )
   
   -- ----------------------------------------------------------------------------------------
   -- verifica permissao de acesso do usuario retornando os flags necessarios
   -- ----------------------------------------------------------------------------------------
   flag_org, flag_unid, org_cod, org_sigla, unid_cod, unid_sigla, associacao = validaAcesso()        
    
   if associacao then
      -- ----------------------------------------------------------------------------------------
      -- monta condicao de AN e UN de acordo com o resultado de ASSOCIACAO
      -- ----------------------------------------------------------------------------------------   
      cond_org = montaCondicao( associacao, flag_org, flag_unid, org_cod, unid_cod, 'a', cgi.recebe_orgao, cgi.recebe_unidade )          
   
   else   -- se o usuario tem ACESSO COMPLETO (nao tem associacao)
      if temConteudo(cgi.recebe_orgao) then
         cond_org  = ' a.org_cod IN (' .. cgi.recebe_orgao .. ') '       
      end  
      if temConteudo(cgi.recebe_unidade) then           
         cond_unid = ' a.unid_cod IN (' .. cgi.recebe_unidade .. ') '        
      end   
   end      
   
   if temConteudo( cgi.recebe_gerencia ) then
      cond_ger = ' a.ger_cod IN (' .. cgi.recebe_gerencia .. ') '
   end
   
   if temConteudo( cgi.recebe_classificacao ) then
      cond_class = ' f.clas_cod IN (' .. cgi.recebe_classificacao .. ') AND a.proj_cod = f.proj_cod '
   end   
   if temConteudo( cgi.recebe_subclassificacao ) then
      cond_subclass = ' f.proj_ot_subcl_cod IN (' .. cgi.recebe_subclassificacao .. ') '
   end  

   cond = ''
   
   if temConteudo( cond_org ) then
      cond = cond .. cond_org
   end   
   if temConteudo( cond_unid ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND ' .. cond_unid
      else
         cond = cond_unid
      end
   end   
   if temConteudo( cond_ger ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND ' .. cond_ger
      else
         cond = cond_ger
      end
   end   
   if temConteudo( cond_class ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND ' .. cond_class
      else
         cond = cond_class
      end
   end   
   if temConteudo( cond_subclass ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND ' .. cond_subclass
      else
         cond = cond_subclass
      end
   end
   if temConteudo( cgi.prioridade ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND proj_prior = ' .. cgi.prioridade
      else
         cond = ' proj_prior = ' .. cgi.prioridade
      end
   end
   if temConteudo( cgi.class_acompanhamento ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND a.proj_class = ' .. cgi.class_acompanhamento
      else
         cond = ' a.proj_class = ' .. cgi.class_acompanhamento
      end
   end
   if temConteudo( cgi.plano_rec ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND proj_plano_rec = '.. cgi.plano_rec
      else
         cond = ' proj_plano_rec = ' .. cgi.plano_rec
      end
   end
   if temConteudo( cgi.plano_dut ) then
      if tonumber(cgi.plano_dut) == 1 then
         cond_plano_dut = 'proj_paeid = 1'
      elseif tonumber(cgi.plano_dut) == 0 then
         cond_plano_dut = '(proj_paeid = 0 OR proj_paeid IS NULL)'
      end   
      if ( cond ~= '' ) then
         cond = cond .. ' AND ' .. cond_plano_dut
      else
         cond = cond_plano_dut
      end
   end
   if temConteudo( cgi.cod_usuario ) then
      if ( cond ~= '' ) then
      	 cond = cond .. " AND proj_cod_usuario like '%" .. cgi.cod_usuario .. "%'"
      else
         cond = " proj_cod_usuario like '%" .. cgi.cod_usuario .. "%'"
      end
   end       
   if temConteudo( cgi.metas ) then
      if ( cond ~= '' ) then
      	 cond = cond .. ' AND proj_meta = ' .. cgi.metas
      else
         cond = ' proj_meta = ' .. cgi.metas
      end
   end 
   
   dataip = inclui_data(cgi.data_inicio_previsto)
   datatp = inclui_data(cgi.data_termino_previsto)
   datair = inclui_data(cgi.data_inicio_real)
   datatr = inclui_data(cgi.data_termino_real)
   
   dataop1 = cgi.data_inicio_prev
   dataop2 = cgi.data_termino_prev
   dataop3 = cgi.data_in_real
   dataop4 = cgi.data_term_real        

   if temConteudo( cgi.status ) then      
      if temConteudo( cond ) then
         cond = cond .. ' AND a.stat_cod = ' .. cgi.status
      else
         cond =' a.stat_cod = ' .. cgi.status
      end
   end   
   if temConteudo( dataip ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND proj_dt_ini_prev ' .. dataop1 .. ' \'' .. dataip .. '\''
      else
         cond = ' a.proj_dt_ini_prev ' .. dataop1 .. ' \'' .. dataip .. '\''
      end
   end
   if temConteudo( datatp ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND proj_dt_fim_prev ' .. dataop2 .. ' \'' ..  datatp .. '\''
      else
         cond = ' a.proj_dt_fim_prev ' .. dataop2 .. ' \'' .. datatp .. '\''
      end
   end
   if temConteudo( datair ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND proj_dt_ini_real ' .. dataop3 .. '\'' .. datair .. '\''
      else
         cond = ' a.proj_dt_ini_real ' .. dataop3 .. ' \'' ..  datair .. '\''
      end
   end
   if temConteudo( datatr ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND proj_dt_fim_real ' .. dataop4 .. ' \'' .. datatr .. '\''
      else
         cond = ' a.proj_dt_fim_real ' .. dataop4 .. ' \'' .. datatr .. '\''
      end
   end 
   if temConteudo( cgi.desempenho ) then
      if ( cond ~= '' ) then
         cond = cond .. ' AND a.proj_desempenho = '.. cgi.desempenho
      else
         cond = ' a.proj_desempenho = ' .. cgi.desempenho
      end
   end           

   cgi.pagina = 'result_consulta.html'

   temp = {}
           
   campos    = "SELECT DISTINCT a.proj_cod, a.proj_nome, a.proj_class, a.org_cod, b.org_sigla, a.unid_cod, c.unid_sigla, "..
               "a.ger_cod, a.stat_cod, a.proj_prior, a.proj_plano_rec, a.proj_cod_usuario, a.proj_dt_ini_prev, "..
               "a.proj_dt_fim_prev, a.proj_dt_ini_real, a.proj_dt_fim_real, a.proj_desempenho, d.desempenho_descr, "..
               "e.stat_descr "
   tabelas   = "FROM projeto a, orgao b, unidade c, desempenho d, status e  "
   cond_fixa = "WHERE a.last_versao = 's' AND a.org_cod = b.org_cod AND a.unid_cod *= c.unid_cod AND "..
               "a.proj_desempenho = d.desempenho_cod AND a.stat_cod = e.stat_cod "  
   ordem     = " ORDER BY a.proj_nome, b.org_sigla, c.unid_sigla, e.stat_descr "                            
   
   -- ------------------------------------------------------------------------------------------------------
   -- Garantir a ordem alfabetica dos PROJETOS caso o usuario escolha em informacoes campos como AN-sigla e
   -- UN-sigla, pois o ORDER BY irah ordenar por ORG_SIGLA, depois por UNID_SIGLA e entao por PROJ_NOME
   -- Dependendo se aparecam ou nao AN e UN em cgi.recebe_informacoes o ORDER BY pode ser alterado 
   -- Quando esses campos nao sao selecionados, ordena por PROJ_NOME, ORG_SIGLA e UNID_SIGLA
   -- ------------------------------------------------------------------------------------------------------
   if temConteudo(cgi.recebe_informacoes) then    
      if strfind(','..cgi.recebe_informacoes..',', ',area_negocio,' ) and strfind(','..cgi.recebe_informacoes..',', ',unidade_negocio,') then
         ordem = " ORDER BY b.org_sigla, c.unid_sigla, e.stat_descr, a.proj_nome "
      elseif strfind(','..cgi.recebe_informacoes..',', ',area_negocio,') then
         ordem = " ORDER BY b.org_sigla, e.stat_descr, a.proj_nome "
      elseif strfind(','..cgi.recebe_informacoes..',', ',unidade_negocio,') then
         ordem = " ORDER BY c.unid_sigla, e.stat_descr, a.proj_nome "      
      elseif strfind(','..cgi.recebe_informacoes..',', ',status,') then
         ordem = " ORDER BY e.stat_descr, a.proj_nome "                         
      end
   end          

   if temConteudo( cgi.recebe_classificacao ) or temConteudo( cgi.recebe_subclassificacao ) then
      tabelas   = tabelas .. ", proj_ot f "      
   end      
   
   if temConteudo( cond ) then
      str = campos..tabelas..cond_fixa.." AND "..cond..ordem
   else
      str = campos..tabelas..cond_fixa..ordem
   end   

   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end     

   proj_inter = {}
   var_proj_cod = ''
 
   DBExec(str)      
   temp = DBRow()
  
   i = 1      
   while ( temp and temp.proj_cod ) do           
      proj_inter[i] = temp
      
      if var_proj_cod ~= '' then 
         var_proj_cod = var_proj_cod..','
      end
      var_proj_cod = var_proj_cod..temp.proj_cod   
         
      temp = DBRow()
      i = i + 1
   end
   cont_proj = i - 1        
  
   -- -------------------------------------------------------------------------------------------
   -- Se var_proj_cod for um valor muito grande, ocorrerao erros na passagem de CGI e pra gravar
   -- no banco, portanto, se isso acontecer o que eh passado pro script de gravacao eh a query 
   -- ------------------------------------------------------------------------------------------- 
   if temConteudo(cond) then   
      -- Mantem o valor de _TAM_CGI_ 
      dofile( 'constantes.lua' )
      -- tamanho da string que armazena os codigos de projeto 
      tamanho = strlen(var_proj_cod)
      -- O elemento da comparacao diz respeito ao tamanho do CGI passado por parametro      
      if tamanho > _TAM_CGI_ then         
         write('<INPUT TYPE="hidden" NAME="var_proj_query" VALUE="',str,'">') 
      else   
         write('<INPUT TYPE="hidden" NAME="var_proj_cod" VALUE="',var_proj_cod,'">') 
      end
   end
     
   if cgi.recebe_informacoes and cgi.recebe_informacoes ~= '' then
      write('<INPUT TYPE="hidden" NAME="informacoes" VALUE="',cgi.recebe_informacoes,'">')
   end
   write('<FONT class=pageTitle><center>Relatrio de Projetos - Resultado</center></FONT>\n')
   
   flag_resultado_consulta = 1	
 
   if ( not( temConteudo(var_proj_cod) ) ) then
      write('<HR WIDTH=98%><BR>\n')
      write('<FONT class=fieldLabel><center> Nenhum projeto satisfaz tais condies!</center></FONT><BR><BR>' )     	    	      
   
   else 
      tipo = 'relatorio'                   
         
      listaProjsporOrgao( proj_inter, cont_proj )     
           
      write('<BR><CENTER>')
      if ( cons_gravada ~= 1 ) and 
         ( temConteudo(cond) and ( cond ~= cond_org or (cond == cond_org and temConteudo(cgi.recebe_orgao)) ) )then
         write('<TABLE border="0"><TR><TD><B>Nome do Relatrio: </B></TD><td><INPUT TYPE="TEXT" NAME="nome_cons_perso"></td></TR><TR><TD colspan="2">&nbsp;</TD></TR>\n')  
         write('<TR><TD><B>Nome da Lista: </B></TD><td><INPUT TYPE="TEXT" NAME="nome_lista_perso"></TD></TR>\n')
         write('<TR><TD colspan="2">&nbsp;</TD></TR></TABLE>\n') 
         write([[<A HREF="javascript:document.form1.acao.value='Grava Consulta'; document.form1.submit();" OnMouseOver="Over('bot-grav');" OnMouseOut="Out('bot-grav');" ONCLICK="document.form1.acao.value='Grava Consulta';"><IMG SRC="../imagens/bot-grav.gif" BORDER="0" NAME="bot-grav"></A>]])                                 
      elseif not( temConteudo(cond) ) or ( cond == cond_org ) then        
         write('<BR><FONT class=fieldLabel><center> No  possvel gravar relatrio pois nenhuma condio foi definida! </center></FONT><BR><BR>' )
      end                   
      write('</FORM>\n')
      --write('<FORM NAME="FORM2" ACTION="../relat_outro.html">\n')
      write('<FORM NAME="FORM2" ACTION="../filtro_projetos.html">\n')
   end
   
   if ( cons_gravada == 1 ) then
      write('<FONT class=fieldLabel><CENTER>Relatrio Gravado!</FONT><BR>\n')
      write('<BR>')
   elseif ( cons_gravada == 0 )then
      write('<FONT class=msgErro><CENTER>Voc j possui um relatrio com este nome!</FONT><BR>\n')
      write('<BR>')      
   end
   
   write([[<center><A HREF="javascript:history.back();" OnMouseOver="Over('bot-voltar');" OnMouseOut="Out('bot-voltar');"><IMG SRC="../imagens/bot-voltar.gif" BORDER="0" NAME="bot-voltar"></A></center>]])    	                  
   write('</FORM>\n</CENTER>\n')
   write('</BODY>\n')
   write('</HTML>\n')
   
   if ESTADO_BD == 'aberto' then
      FechaBD()
   end
   
end
