assert(dofile("global.lua"))
assert(dofile("acessabd.lua"))

if ESTADO_BD ~= 'aberto' then
      AbreBD()
end

-- FILTRO DA CONSOLIDACAO    
str = "SELECT DISTINCT p.proj_cod, p.proj_nome FROM projeto p , custo c "..
      "   where p.unid_cod = "..cgi.unidade.." AND p.stat_cod = 2 AND "..
      "   p.last_versao = 's'  AND p.proj_cod=c.proj_cod AND (c.custo_ano >= year(p.proj_dt_ini_prev) AND "..
      "   c.custo_ano <= year(p.proj_dt_fim_prev) AND c.custo_prev_ano = 0) "..
      "   UNION "..
      "   SELECT DISTINCT p.proj_cod, p.proj_nome FROM projeto p, proj_ot o "..
      "   WHERE  p.unid_cod = "..cgi.unidade.." AND p.stat_cod = 2 AND "..
      "   p.last_versao = 's' AND p.proj_cod=o.proj_cod AND ( p.proj_num_ote IS NULL OR p.proj_num_ote = '' ) AND "..
      "   ( o.ot_oper_cod IS NULL OR o.ot_oper_cod = '' ) "..
      "   UNION "..
      "   SELECT p.proj_cod, p.proj_nome FROM projeto p, transpetro t "..
      "   WHERE  p.unid_cod = "..cgi.unidade.." AND p.stat_cod = 2 AND p.last_versao = 's' AND "..
      "   p.proj_cod=t.proj_cod AND ( t.trans_tipo IS NULL OR t.trans_tipo = '' ) "..
      "   UNION "..
      "   SELECT proj_cod, proj_nome FROM projeto "..
      "   WHERE  unid_cod = "..cgi.unidade.." AND stat_cod = 2 AND last_versao = 's'  AND "..
      "   ( proj_class IS NULL OR proj_class = '' ) "..
      "   UNION "..
      "   SELECT DISTINCT p.proj_cod, p.proj_nome "..
      "   FROM projeto p, atividade at "..
      "   WHERE p.proj_cod = at.proj_cod "..
      "   AND p.unid_cod = "..cgi.unidade.." AND p.last_versao = 's' "..
      "   AND p.stat_cod = 2 "..
      "   AND ((convert(datetime, at.ativ_dt_ini_prev) <  p.proj_dt_ini_prev "..
      "         OR convert(datetime, at.ativ_dt_fim_prev) < p.proj_dt_ini_prev) "..
      "       OR (convert(datetime, at.ativ_dt_ini_prev) >  p.proj_dt_fim_prev "..
      "         OR convert(datetime, at.ativ_dt_fim_prev) > p.proj_dt_fim_prev)) "..
      "   order by p.proj_nome"
      

DBExec(str)
plinha = DBRow()

   
if plinha then
   cgilua.htmlheader()
   write('<HTML>')
   write('<HEAD>')
   write('<TITLE>Registro de Consolidao de Unidade</TITLE>')
   write('<LINK REL="stylesheet" HREF="../pegaso.css" TYPE="text/css">')
   write('<SCRIPT LANGUAGE="Javascript">')
   write('var alerta = window.open("../aviso_carregando.html?acao=VerConsolidacao","aviso_carregando","toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,width=600,height=10");')
   write('</SCRIPT>')
   write('<SCRIPT SRC="../pegaso.js"></SCRIPT>')
   write('</HEAD>')
   write('<BODY BACKGROUND="../imagens/moldura_princ.gif" onLoad="alerta.close();">')
   write('<FONT class=pageTitle><center>Projetos fora da especificao para Consolidao</center></FONT>')
   write('<FORM NAME="form1" METHOD="post">')
   write('<HR WIDTH="98%">')
   write('<table border=0 width="100%">')
   write('<tr>')
   write('<td> ')
   write('</td>')
   write('<td> ')
   write('</td>')
   write('<td><FONT color=red>No  possvel realizar a consolidao da unidade devido a irregularidades nos projetos:'..
         '<UL><LI>no preenchimento do tipo do projeto (Investimento ou Operao); e / ou '..
         '<LI>no preenchimento da classificao do acompanhamento; e / ou'..
         '<LI>no preenchimento de pelo menos umas das OTs do projeto (Operacional ou Especfica); e / ou'..         
         '<LI>no preenchimento de pelo menos um custo previsto anual dentro do perodo do projeto; e / ou'..
         '<LI>no adequao das datas previstas das atividades em relao s datas previstas do projeto. </UL> '..
         '<P>Projetos irregulares:</FONT></P></td>')
   write('</tr>')
   write('</table>')
   write('<table border=0 width="100%">')

   while plinha do
      write('<tr>')
      write('<td colspan=2>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td></tr>')
      write('<tr>')
      write('<td>&nbsp;&nbsp;</td>')
      write('<td>')
      write('<A HREF="../lista_proj_consolidacao.html?unidade='..cgi.unidade..'&cod='..plinha.proj_cod..'&pagina_chamadora=lua/verifica_consolidacao_P1.lua">'..plinha.proj_nome..'</A>')
      write('</td>')
      write('<td> ')
      write('</td>')
      write('</tr>')
      write('</tr>')
      plinha = DBRow()
   end
   
   write('</table>')
   write('<center>')
   write('<P>&nbsp;</P><A HREF="../consolidacao_p1.html?unidade='..cgi.unidade..'" OnMouseOver=Over("bot-voltar"); OnMouseOut=Out("bot-voltar");><IMG SRC="../imagens/bot-voltar.gif" BORDER="0" NAME="bot-voltar"></A>')
   write('</center>')
   write('</FORM>')
   write('</BODY>')
   write('</HTML>')

   if ESTADO_BD == 'aberto' then
      FechaBD()
   end

else
   if ESTADO_BD == 'aberto' then
      FechaBD()
   end
   
   cgilua.redirect('../consolidacao_R1.html?'..cgilua.encodecgi())
end