import java.awt.*;

public class Bar extends Symbol {
  // pos = upperleft; size; 
  int height;
  int width;

  Bar(Point position, int width, int height, Color color)
  {
    this.position = position;
    this.width = width;
    this.height = height;
    this.color = color;
  }

  void draw(Graphics g)
  {
    Color currentColor;

    currentColor = g.getColor();
    g.setColor(color);
    g.fillRect(position.x, position.y, width, height);

    // restore
    g.setColor(currentColor);
  } 
}
