import java.applet.*;
import java.awt.*;

import com.jrefinery.data.DefaultPieDataset;
import com.jrefinery.chart.ChartFactory;
import com.jrefinery.chart.JFreeChart;
import com.jrefinery.chart.ChartFrame;
import com.jrefinery.chart.ChartPanel;
import com.jrefinery.chart.ChartMouseEvent;
import com.jrefinery.chart.ChartMouseListener;
import com.jrefinery.chart.plot.PiePlot;

public class PieChart3D extends Applet{
   static String title;
   static int width;
   static int height;
   static int miniWidth;
   static int miniHeight;
   static int maxiWidth;
   static int maxiHeight;
   static String perc;

   public void init() {
      int NumElem,i;
      DefaultPieDataset data;
      JFreeChart chart;
      ChartPanel panel2;
//      ChartMouseEvent mouse1;
//      String Percent = new String();
//      String Nome = new String();

      // l parmetros do arquivo HTML   
      width    = Integer.parseInt(this.getParameter("width"));
      height   = Integer.parseInt(this.getParameter("height"));
      miniWidth   = Integer.parseInt(this.getParameter("minimumDrawWidth"));
      miniHeight   = Integer.parseInt(this.getParameter("minimumDrawHeight"));
      maxiWidth   = Integer.parseInt(this.getParameter("maximumDrawWidth"));
      maxiHeight   = Integer.parseInt(this.getParameter("maximumDrawHeight"));

      title = this.getParameter("title");
      NumElem = Integer.parseInt(getParameter("numelem"));


      // Criando um dataset...
      data = new DefaultPieDataset();

      for (i=0;i<NumElem;i++)
      {
         data.setValue((String)(getParameter("nome" + (i+1))),Float.parseFloat((String)(getParameter("percent" + (i+1)))));
      }
   
      // Criando um chart (titulo,dados,legendo,xxx,url)
      chart = ChartFactory.createPie3DChart(title, data, true, true, false);
      
      // Pano de fundo de cor branca
      chart.setBackgroundPaint(Color.white);

      /*Determina que tipo de campo sera esposto no label
       * type -> NO_LABELS,
       * NAME_LABELS, VALUE_LABELS, PERCENT_LABELS, NAME_AND_VALUE_LABELS,
       * NAME_AND_PERCENT_LABELS, VALUE_AND_PERCENT_LABELS)
       */
      PiePlot plot = (PiePlot)chart.getPlot();

      plot.setSectionLabelType(PiePlot.PERCENT_LABELS);
      
      // Criando e mostrando em um panel...

//      panel2 = new ChartPanel(chart);

      panel2 = new ChartPanel(chart,width,height,miniWidth,miniHeight,maxiWidth,maxiHeight,true,true,true,true,true,true);
      
//      panel2.setPreferredSize(new Dimension(width,height));
      
      //Estende o panel ate que o mesmo ocupe o tamanho determinado para o applet
      setLayout(new BorderLayout());
      
      //Visualiza o applet
      add(panel2);

   }	
}