-- ----------------------------------------------------------------------------------------------------------------
-- CONCLUI.LUA
-- ----------------------------------------------------------------------------------------------------------------
if cgi.acao == 'Conclui' then
   dofile ( 'acessabd.lua' )
   dofile ( 'global.lua' )
   dofile ( 'mail.lua' ) 
   
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end   
   
   -- Retorna o codigo do responsavel(usuario corrente) pela formalizacao.
   resp_conc = retornaPessoaCod(getuser())
   
   -- Retorna a data atual
   dataconc = DataAtual()
    
   dtfimreal_proj = ConsultaBD("projeto","proj_dt_fim_real","proj_dt_fim_real IS NOT NULL",nil)   
   if dtfimreal_proj.proj_dt_fim_real then  
      dtfimreal_ativ = ConsultaBD("atividade","ativ_dt_fim_real","ativ_dt_fim_real IS NOT NULL",nil)       
      if dtfimreal_ativ.ativ_dt_fim_real then      	
         AlteraBD( "projeto", " stat_cod = 4, proj_resp_conc = "..resp_conc..", proj_dt_conc = '"..dataconc.."' ", " proj_cod = "..tonumber(cgi.cod).."")         
               
         -- ---------------------------------------------------------------------------------------         
         -- Atualizao da tabela de FOLLOW_UP quando o projeto eh CONCLUIDO
         -- ---------------------------------------------------------------------------------------                                                                                                                                    
            atualizaFollowUp(cgi.cod,1,'Concluso do projeto.')
            
         -- ----------------------------------------------------------------------------------------------------------
         -- Executa a funcao EMAIL da pagina MAIL.LUA para enviar os e-mails aos responsaveis..
         -- ----------------------------------------------------------------------------------------------------------         
            msgsuc, email = email(cgi.cod, 'conclui')
            
            if ESTADO_BD == 'aberto' then
               FechaBD()
            end
            cgilua.redirect( '../visualiza.html?'..cgilua.encodetable({ tipo_servico = cgi.tipo_servico, cond_filtro = cgi.cond_filtro, msgsuc = msgsuc, email = email, quadroAtivo = cgi.quadroAtivo }) )                                                             
      else
         msgerro = "Projeto no foi concludo, verifique se as datas de Incio e Trmino Real das Atividades esto preenchidas!"
         
         if ESTADO_BD == 'aberto' then
            FechaBD()
         end         
         cgilua.redirect( '../exibe_dados_projeto.html?'..cgilua.encodetable({ tipo_servico = cgi.tipo_servico, cond_filtro = cgi.cond_filtro, msgerro = msgerro }) ) -- VOLTA PARA A PGINA html      
      end  
   else
      msgerro = "Projeto no foi concludo, verifique se as datas de Incio e Trmino Real do Projeto esto preenchidas!"
      
      if ESTADO_BD == 'aberto' then
         FechaBD()
      end      
      cgilua.redirect( '../exibe_dados_projeto.html?'..cgilua.encodetable({ tipo_servico = cgi.tipo_servico, cond_filtro = cgi.cond_filtro, msgerro = msgerro }) ) -- VOLTA PARA A PGINA html      
   end  
          
end