-- -------------------------------------------------------------------------------------------
-- DATA_CONSOLIDACAO.LUA
-- -------------------------------------------------------------------------------------------
   assert( dofile( "global.lua" ) )
   assert( dofile( "acessabd.lua" ) )
   assert( dofile( "constantes.lua" ) )

   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end    

-- ---------------------------------------------------------------------------------------------
   function stringDataToSqlStringData(stringData)
   
     i,f,d,m,a = strfind(stringData,"(%d*)/(%d*)/(%d*)")     
     resposta = a.."-"..m.."-"..d     
     return(resposta)
   end
  
-- ---------------------------------------------------------------------------------------------
   function limpaCampos()
      cgi.data   = ''      
   end       
   
-- ---------------------------------------------------------------------------------------------
-- VERIFICACAO DA OPCAO SELECIONADA
-- ---------------------------------------------------------------------------------------------  
if cgi.acao == 'Limpa' then
   limpaCampos()
   
   if ESTADO_BD == 'aberto' then
      FechaBD()
   end   
   -- ---------------------------------------------------------------------------------------------
   -- VOLTA PARA A PGINA html
   -- ---------------------------------------------------------------------------------------------    
      cgilua.redirect(cgi.pagina)
    
   -- ---------------------------------------------------------------------------------------------
   -- Evita que o restante do cdigo seja executado
   -- ---------------------------------------------------------------------------------------------
      exit()
    
elseif cgi.acao == 'Grava' then   
   -- ---------------------------------------------------------------------------------------------	
   -- CARREGA A BIBLIOTECA VALIDAFORM 
   -- ---------------------------------------------------------------------------------------------
      assert(dofile("../validaform/validaform.lua"))
      assert(dofile("form_data_consolidacao.lua"))

   -- ---------------------------------------------------------------------------------------------	
   -- ---------------------------------------------------------------------------------------------	
   -- Faz a validao do formulrio com o FORM_DATA_CONSOLIDACAO.LUA
   -- ---------------------------------------------------------------------------------------------
   -- ---------------------------------------------------------------------------------------------	
      cgi.msg = form_data_consolidacao:critica()   
   
      if temConteudo(cgi.msg) then 
         if ESTADO_BD == 'aberto' then
            FechaBD()
         end     	
         -- ---------------------------------------------------------------------------------------------
         -- VOLTA PARA A PGINA html carregando os valores de unidade/orgao e a mensagem do VALIDAFORM
         -- ---------------------------------------------------------------------------------------------              
            cgilua.redirect(cgi.pagina..'?'..cgilua.encodetable({ano = cgi.ano, unidade = cgi.unidade, msg = cgi.msg}))
      elseif not(temConteudo(cgi.dip)) then
        if ESTADO_BD == 'aberto' then
           FechaBD()
        end
      	cgilua.redirect(cgi.pagina..'?'..cgilua.encodetable({ano = cgi.ano, unidade = cgi.unidade, msg = "DIP  um campo obrigatrio"}))
      else
         -- ---------------------------------------------------------------------------------------------
         -- Verifica se jah existe alguma consolidacao em aberto
         -- ---------------------------------------------------------------------------------------------                      
         consultaSQL = "Select * from consolidacao where ativa = 1"         
         DBExec(consultaSQL)         
         if DBRow() then
           cgi.msg = "J existe data de consolidao em aberto."
           if ESTADO_BD == 'aberto' then
              FechaBD()
           end
           cgilua.redirect(cgi.pagina..'?'..cgilua.encodetable({msg = cgi.msg}))
         else
           insertSQL = "insert into consolidacao (cons_dt_prev,DIP, ativa) values ('"..stringDataToSqlStringData(cgi.data).."','"..cgi.dip.."',1)"           
           DBExec(insertSQL)           
         end       
                                                 
         sucesso = 'As datas foram cadastradas com sucesso!'
         
         if ESTADO_BD == 'aberto' then
            FechaBD()
         end       
         -- ---------------------------------------------------------------------------------------------
         -- VOLTA PARA A PGINA html carregando os valores das datas e de unidade/orgao
         -- ---------------------------------------------------------------------------------------------                
         cgilua.redirect(cgi.pagina..'?'..cgilua.encodetable({ data = cgi.data, msg_suc = sucesso}))
     end 
      
elseif cgi.acao == 'Altera'  then 
   -- ---------------------------------------------------------------------------------------------	
   -- CARREGA A BIBLIOTECA VALIDAFORM 
   -- ---------------------------------------------------------------------------------------------
      assert(dofile("../validaform/validaform.lua"))
      assert(dofile("form_data_consolidacao.lua"))

   -- ---------------------------------------------------------------------------------------------	
   -- ---------------------------------------------------------------------------------------------	
   -- Faz a validao do formulrio com o FORM_DATA_CONSOLIDACAO.LUA
   -- ---------------------------------------------------------------------------------------------
   -- ---------------------------------------------------------------------------------------------	
      cgi.msg = form_data_consolidacao:critica()   
   
      if temConteudo(cgi.msg) then 
         if ESTADO_BD == 'aberto' then
            FechaBD()
         end             	
         -- ---------------------------------------------------------------------------------------------
         -- VOLTA PARA A PGINA html carregando os valores de unidade/orgao e a mensagem do VALIDAFORM
         -- --------------------------------------------------------------------------------------------- 
            cgilua.redirect(cgi.pagina..'?'..cgilua.encodetable({msg = cgi.msg}))
      elseif not(temConteudo(cgi.dip)) then
        if ESTADO_BD == 'aberto' then
           FechaBD()
        end        
      	cgilua.redirect(cgi.pagina..'?'..cgilua.encodetable({ano = cgi.ano, unidade = cgi.unidade, msg = "DIP  um campo obrigatrio"}))
      else
         -- ---------------------------------------------------------------------------------------------
         -- Verifica se a data  menor do que alguma jah inserida
         -- ---------------------------------------------------------------------------------------------             
            sqlConsulta = "select cons_dt_prev as maxData from consolidacao where ativa = 0"
            DBExec(sqlConsulta)
            rs = DBRow()
            
            if rs and inclui_data(cgi.data) <= inclui_data(rs.maxdata) then
            	cgi.msg = "Data menor que a da ultima consolidao."
              if ESTADO_BD == 'aberto' then
                 FechaBD()
              end            	
            	cgilua.redirect(cgi.pagina..'?'..cgilua.encodetable({msg = cgi.msg}))
            end
            
            sqlAltera = "Update consolidacao set cons_dt_prev = '"..stringDataToSqlStringData(cgi.data).."', dip = '"..cgi.dip.."' where ativa = 1";
            DBExec(sqlAltera)
            
            sucesso = 'A data foi alterada com sucesso!'
            
            if ESTADO_BD == 'aberto' then
               FechaBD()
            end                              
            -- ---------------------------------------------------------------------------------------------
            -- VOLTA PARA A PGINA html carregando os valores das datas e de unidade/orgao
            -- ---------------------------------------------------------------------------------------------                
            cgilua.redirect(cgi.pagina..'?'..cgilua.encodetable({ data = cgi.data, msg_suc = sucesso}))            
      end 
elseif cgi.acao == 'Fecha' then 
  if ESTADO_BD == 'aberto' then
     FechaBD()
  end    	
  cgilua.redirect('../data_consolidacaoConfirmaFechamento.html');
end      