-- ---------------------------------------------------------------------------------------
-- FORM_CADASTRA.LUA
-- ---------------------------------------------------------------------------------------
if temConteudo(cgi.dt_ini_prevista) then
   dt_ini_prev = inclui_data(cgi.dt_ini_prevista)
   mensagem = 'data de incio prevista para o projeto ('..cgi.dt_ini_prevista..')'
else   
   dt_ini_prev = _DATA_INI_PEGASO_ 
   mensagem = _DATA_INI_PEGASO_DESC_
end   

if not( temConteudo(cgi.custo_previsto_2000) ) then
   cgi.custo_previsto_2000 = 0
end
if not( temConteudo(cgi.custo_previsto_2001) ) then
   cgi.custo_previsto_2001 = 0
end
if not( temConteudo(cgi.custo_previsto_2002) ) then
   cgi.custo_previsto_2002 = 0
end
if not( temConteudo(cgi.custo_previsto_2003) ) then
   cgi.custo_previsto_2003 = 0
end

-- ----------------------------------------------------------------------------------------
-- ----------------------------------------------------------------------------------------
-- MONTAGEM DO FORMULARIO
-- ----------------------------------------------------------------------------------------
-- ----------------------------------------------------------------------------------------
   elementos =
   {
      CampoListaComOutro:new { 'OT Operacional', "ot_operacional", nil , cgi.ot_oper },
      CampoAlfanumerico:new { 'OT Especfica', "ot_especifica",nil, nil, nil, cgi.ot_especifica}
   }

   form_cadastra = Formulario:new 
   {{
         CampoListaComOutro:new { 'rgo', "orgao","sim", cgi.orgao },
         CampoListaComOutro:new { 'Classificao', "classificacao","sim", cgi.classificacao },
         CampoListaComOutro:new { 'Metas', "metas", "sim" , cgi.metas },
         CampoCaracter:new { 'Projeto', "projeto","sim", nil, nil, cgi.projeto},  
         CampoRadio:new { 'Classificao do Acompanhamento do Projeto', "class_acomp","sim",cgi.class_acomp}, 
         --CampoListaComOutro:new { 'OT Operacional', "ot_operacional", nil , cgi.ot_oper },
         --CampoAlfanumerico:new { 'OT Especfica', "ot_especifica",nil, nil, nil, cgi.ot_especifica},  
         CampoCaracter:new { 'Coordenador', "coordenador","sim", nil, nil, cgi.coordenador},  
         CampoListaComOutro:new { 'Frequncia de Follow-up', "frequencia","sim", cgi.freq},
         CampoListaComOutro:new { 'Prioridade', "prioridade","sim", cgi.prioridade },
         CampoRadio:new { 'Plano Emergencial de Integridade de Dutos', "plano_emerg_duto","sim",cgi.plano_emerg_duto}, 
         CampoData:new 
          {
             'Data prevista para o Inicio', 'dt_ini_prevista', 'sim',
             { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = _DATA_INI_PEGASO_DESC_ , valor = _DATA_INI_PEGASO_
                   },
   
                   ['<='] = 
                   { 
                      nome = _DATA_FIM_PEGASO_DESC_ , valor = _DATA_FIM_PEGASO_ 
                   } 
                } 
             }, nil, 
   	       cgi.dt_ini_prevista, "texto" 
   	    }, 
   
   	    CampoData:new 
          {
             'Data prevista para o fim', 'dt_fim_prevista', 'sim',
             { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = mensagem , valor = dt_ini_prev
                   },
   
                   ['<='] = 
                   { 
                      nome = _DATA_FIM_PEGASO_DESC_ , valor = _DATA_FIM_PEGASO_ 
                   } 
                } 
             }, nil, 
   	       cgi.dt_fim_prevista, "texto" 
   	    }, 
   
          CampoReal:new {'Custo previsto para 2000', 'custo_previsto_2000', nil, 
             { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, cgi.custo_previsto_2000 },
          CampoReal:new {'Custo previsto para 2001', 'custo_previsto_2001', nil, 
             { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, cgi.custo_previsto_2001 },
          CampoReal:new {'Custo previsto para 2002', 'custo_previsto_2002', nil, 
             { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, cgi.custo_previsto_2002 },
          CampoReal:new {'Custo previsto para 2003', 'custo_previsto_2003', nil, 
             { 
                limite = 
                { 
                   ['>='] = 
                   { 
                      nome = '0', valor = 0
                   },
                } 
             }, nil, cgi.custo_previsto_2003 },
         
           CampoCaracter:new 
           { 
              'Descrio', "descricao",nil,  
              {       
                 tamanho =     
                 {     
                    ['<='] = 300 
                 }
              },nil,cgi.descricao   
           },      
                    
          CampoRadio:new { 'Tipo', "tipo", "sim", cgi.tipo },        
          CampoAlfanumerico:new { 'CAC', "cac",nil, nil, nil, cgi.cac },
          CampoAlfanumerico:new { 'CAD', "cad",nil, nil, nil, cgi.cad },       
          CampoAlfanumerico:new { 'CBI', "cbi",nil, nil, nil, cgi.cbi },
          CampoAlfanumerico:new { 'UI', "ui",nil, nil, nil, cgi.ui },
          CampoAlfanumerico:new { 'Programa', "programa",nil, nil, nil, cgi.programa },       
          CampoAlfanumerico:new { 'Projeto', "projeto",nil, nil, nil, cgi.projeto },              



         CampoListaComOutro:new { 'Estado', "estado_un","sim", cgi.estado_un },
         CampoRadio:new { 'Funcao', "funcao_un", "sim", cgi.funcao_un },        
         CampoRadio:new { 'Tipo de Ao', "tipo_un", "sim", cgi.tipo_un },        


          
          CampoComposto:new 
          { 
             'OT', "ot", "sim", 
             { 
                subconjunto = "#indeterminado",
                tamanho = 
                { 
                   ['>='] = 1  
                }
             }, "global", 2, elementos
          }
   }}
