dofile( 'acessabd.lua' )
dofile( 'global.lua' )  
dofile( 'permissao_acesso.lua' ) 

if ESTADO_BD ~= 'aberto' then
   AbreBD()
end

flagUN = 0
flagAN = 0

if ( cgi.acao == "Criar Relatorio" ) and tonumber(cgi.anoIni) <= tonumber(cgi.anoFim) then
   cgilua.htmlheader() 
   
   write('<HTML>\n')
   write('<HEAD>\n')
   write('<LINK REL="stylesheet" HREF="../pegaso.css" TYPE="text/css">\n')
   write('<TITLE>Resultado do Relatrio Financeiro</TITLE>\n')
    
   write('<SCRIPT LANGUAGE="JavaScript">\n')
   write('var selecionado = null;\n')  
   write('function Over(nome)\n')
   write('{\n')
   write('   if (selecionado != null)\n')
   write('   {\n')
   write('      Out(selecionado);\n')
   write('   }\n')
   write('   document[nome].src="../imagens/" + nome + "2.gif";\n')
   write('}\n')
   write('function Out(nome)\n')
   write('{\n')
   write('   if (nome != selecionado)\n')
   write('   {\n')
   write('      document[nome].src="../imagens/" + nome + ".gif";\n')
   write('   }\n')
   write('}\n')
   write('</SCRIPT>\n') 
     
   write('</HEAD>\n')
   write('<BODY BACKGROUND="../imagens/moldura_princ.gif">\n')
   write('\n')
   if tonumber(cgi.anoIni) == tonumber(cgi.anoFim) then
      write('   <CENTER><H2>Resultado do Relatrio Financeiro de '..cgi.anoIni..'</H2></CENTER>\n')
   else
      write('   <CENTER><H2>Resultado do Relatrio Financeiro de '..cgi.anoIni..' a '..cgi.anoFim..'</H2></CENTER>\n')
   end      
   write('   <HR WIDTH="98%">\n')   
   
   write('   <TABLE WIDTH="100%" BORDER="0" ALIGN="CENTER">\n')
   write('      <TR>\n')
   write('         <TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>\n')
   write('         <TD>\n')
   write('         <TABLE WIDTH="90%" BORDER="0" ALIGN="CENTER">\n')
   
   -- ----------------------------------------------------------------------------------------
   -- verifica permissao de acesso do usuario retornando os flags necessarios
   -- ----------------------------------------------------------------------------------------
   flag_org, flag_unid, org_cod, org_sigla, unid_cod, unid_sigla, associacao = validaAcesso()        
   permissao = {} 
   
   if associacao then             
       campo, valor = next( associacao, nil )          -- captura primeiro campo da tabela      
         while campo do               
            permissao[campo] = valor    
            
            campo, valor = next( associacao, campo )   -- captura proximo campo da tabela
         end           
   end      
   
   cond_orgao = ''
   if temConteudo(cgi.orgao) and cgi.orgao ~= "TODAS" then
      cond_orgao = ' AND p.org_cod IN (' .. cgi.orgao .. ') '
   elseif temConteudo(flag_org) then
      cond_orgao = ' AND p.org_cod IN (' .. org_cod .. ') '
   end
   
   somaAN = {}
   somaAN['Etotal']   = {}
   somaAN['Eparcial'] = {}
   somaAN['Eperc']    = {}
   somaAN['Rtotal']   = {}
   somaAN['Rparcial'] = {}
   somaAN['Rperc']    = {}
   
   somaUN = {}
   somaUN['Etotal']   = {}
   somaUN['Eparcial'] = {}
   somaUN['Eperc']    = {}
   somaUN['Rperc']    = {}   
   
   -- -------------------------------------------------
   -- CALCULANDO O PERCENTUAL ESPERADO DE AN 
   -- -------------------------------------------------
   
   queryTotalAN   = [[SELECT p.org_cod, o.org_sigla, SUM(c.custo_prev_ano) AS soma FROM custo c, projeto p, orgao o ]]..
                    [[WHERE c.proj_cod = p.proj_cod AND o.org_cod = p.org_cod AND p.stat_cod <> 3 AND p.last_versao = 's' ]]..cond_orgao..
                    [[GROUP BY p.org_cod, o.org_sigla ORDER BY o.org_sigla]]
                    
   queryParcialAN = [[SELECT p.org_cod, o.org_sigla, SUM(c.custo_prev_ano) AS soma FROM custo c, projeto p, orgao o  ]]..
                    [[WHERE c.proj_cod = p.proj_cod AND o.org_cod = p.org_cod AND p.stat_cod <> 3 AND p.last_versao = 's' ]]..cond_orgao..
                    [[AND custo_ano >= ]]..cgi.anoIni..[[ AND custo_ano <= ]]..cgi.anoFim..[[ ]]..
                    [[GROUP BY p.org_cod, o.org_sigla ORDER BY o.org_sigla]]
   
   DBExec(queryTotalAN)
   total = DBRow()
   
   -- armazena os totais financeiros ESPERADOS de AN
   while total and total.org_cod do
      somaAN['Eparcial'][total.org_cod] = 0
      somaAN['Etotal'][total.org_cod]   = total.soma
      -- preparando as tabelas para receber os valores de UN
      somaUN['Eperc'][total.org_cod] = {}
      somaUN['Rperc'][total.org_cod] = {}
 
      total = DBRow()
   end
   
   DBExec(queryParcialAN)
   parcial = DBRow()
   
   i = 1
   -- armazena os percentuais financeiros ESPERADOS de AN
   while parcial and parcial.org_cod do
      somaAN['Eparcial'][parcial.org_cod] = parcial.soma
      if tonumber(somaAN['Etotal'][parcial.org_cod]) ~= 0 then
      	 somaAN['Eperc'][i] = {}
      	 somaAN['Eperc'][i]['codigo'] = parcial.org_cod
         somaAN['Eperc'][i]['valor']  = format( '%.2f',(somaAN['Eparcial'][parcial.org_cod]/somaAN['Etotal'][parcial.org_cod])*100 )
         i = i + 1
      end
      parcial = DBRow()
   end
   
   -- -------------------------------------------------
   -- CALCULANDO O PERCENTUAL ESPERADO DE UN 
   -- -------------------------------------------------
   queryTotalUN   = [[SELECT p.org_cod, o.org_sigla, p.unid_cod, u.unid_sigla, SUM(c.custo_prev_ano) AS soma FROM custo c, projeto p, orgao o, unidade u ]]..
                    [[WHERE c.proj_cod = p.proj_cod AND p.org_cod = o.org_cod AND p.unid_cod *= u.unid_cod AND p.stat_cod <> 3 AND p.last_versao = 's' ]]..cond_orgao..[[ ]]..
                    [[GROUP BY p.org_cod, o.org_sigla, p.unid_cod, u.unid_sigla ORDER BY o.org_sigla, u.unid_sigla]]
                    
   queryParcialUN = [[SELECT p.org_cod, o.org_sigla, p.unid_cod, u.unid_sigla, SUM(c.custo_prev_ano) AS soma FROM custo c, projeto p, orgao o, unidade u ]]..
                    [[WHERE c.proj_cod = p.proj_cod AND p.org_cod = o.org_cod AND p.unid_cod *= u.unid_cod AND p.stat_cod <> 3 AND p.last_versao = 's' ]]..cond_orgao..
                    [[AND custo_ano >= ]]..cgi.anoIni..[[ AND custo_ano <= ]]..cgi.anoFim..[[ ]]..
                    [[GROUP BY p.org_cod, o.org_sigla, p.unid_cod, u.unid_sigla ORDER BY o.org_sigla, u.unid_sigla]]

   DBExec(queryTotalUN)
   total = DBRow()
   
   -- armazena os totais financeiros ESPERADOS de UN
   while total and total.org_cod do
      if temConteudo(total.unid_cod) then
         if ( temConteudo(cgi.unidade) and tonumber(cgi.unidade) == tonumber(total.unid_cod) ) then  -- se selecionou alguma unidade            
             somaUN['Etotal'][total.unid_cod] = total.soma
         elseif ( temConteudo(cgi.unidade) and cgi.unidade == 'TODAS' ) and 
                ( not( temConteudo(flag_org) ) or                                                    -- verifica permissao acesso                  
                  ( permissao[total.org_cod] and ((tonumber(permissao[total.org_cod]) == 0 or          
                  strfind(','..permissao[total.org_cod]..',', ','..total.unid_cod..',')))) ) then                                                                                                                                             
             somaUN['Etotal'][total.unid_cod] = total.soma
         end    
      end
      total = DBRow()
   end
   
   DBExec(queryParcialUN)
   parcial = DBRow()   
   
   -- Tivemos problemas para manter as ANs e UNs em ordem alfabetica usando simplesmente o comando NEXT
   -- Por isso, tivemos que usar o artificio de guardar os valores (jah ordenados) dentro de indices
   -- numericamente ordenados na tabela para os valores das UNs (sempre comecando por 1 para cada nova AN)
   i = 1
   -- armazena os percentuais financeiros ESPERADOS de UN
   while parcial and parcial.org_cod do
      orgao = parcial.org_cod
      
      if temConteudo(parcial.unid_cod) then
         if ( temConteudo(cgi.unidade) and tonumber(cgi.unidade) == tonumber(parcial.unid_cod) ) then  -- se selecionou alguma unidade            
             somaUN['Eparcial'][parcial.unid_cod] = parcial.soma
         elseif ( temConteudo(cgi.unidade) and cgi.unidade == 'TODAS' ) and 
                ( not( temConteudo(flag_org) ) or                                                      -- verifica permissao acesso
                  (permissao[parcial.org_cod] and ((tonumber(permissao[parcial.org_cod]) == 0  or       
                  strfind(','..permissao[parcial.org_cod]..',', ','..parcial.unid_cod..',')))) ) then
             somaUN['Eparcial'][parcial.unid_cod] = parcial.soma
         end 
            
         -- passa a armazenar o PERCENTUAL ESPERADO
         if somaUN['Eparcial'][parcial.unid_cod] and tonumber(somaUN['Etotal'][parcial.unid_cod]) ~= 0 then
            somaUN['Eperc'][parcial.org_cod][i] = {}
            somaUN['Eperc'][parcial.org_cod][i]['unidade'] = parcial.unid_cod
            somaUN['Eperc'][parcial.org_cod][i]['valor']   = format( '%.2f',(somaUN['Eparcial'][parcial.unid_cod]/somaUN['Etotal'][parcial.unid_cod])*100 )
            i = i + 1
         end
      end
      parcial = DBRow()
      if ( parcial and parcial.org_cod ~= orgao  ) then
      	 i = 1
      end 	 
   end
   
   -- -------------------------------------------------
   -- CALCULANDO O PERCENTUAL REALIZADO DE AN E UN
   -- -------------------------------------------------
   
   queryRealizadoAN = [[SELECT p.org_cod, o.org_sigla, SUM(c.valor_real) AS soma FROM custo_realizado c, projeto p, orgao o ]]..
                      [[WHERE c.proj_cod = p.proj_cod AND p.org_cod = o.org_cod AND p.stat_cod <> 3 AND p.last_versao = 's' ]]..cond_orgao..
                      [[AND year(c.dt_realizacao) >= ]]..cgi.anoIni..[[ AND year(c.dt_realizacao) <= ]]..cgi.anoFim..[[ ]]..
                      [[GROUP BY p.org_cod, o.org_sigla ORDER BY o.org_sigla]]
   
   queryRealizadoUN = [[SELECT p.org_cod, o.org_sigla, p.unid_cod, u.unid_sigla, SUM(c.valor_real) AS soma FROM custo_realizado c, projeto p, orgao o, unidade u ]]..
                      [[WHERE c.proj_cod = p.proj_cod AND p.org_cod = o.org_cod AND p.unid_cod *= u.unid_cod AND p.stat_cod <> 3 AND p.last_versao = 's' ]]..cond_orgao..
                      [[AND year(dt_realizacao) >= ]]..cgi.anoIni..[[ AND year(c.dt_realizacao) <= ]]..cgi.anoFim..[[ ]]..
                      [[GROUP BY p.org_cod, o.org_sigla, p.unid_cod, u.unid_sigla ORDER BY o.org_sigla, u.unid_sigla]]
   
   DBExec(queryRealizadoAN)
   total = DBRow()
   
   -- Armazena o percentual REALIZADO das ANs
   while total and total.org_cod do
      if somaAN['Eparcial'][total.org_cod] and tonumber(somaAN['Eparcial'][total.org_cod]) ~= 0 then          
         somaAN['Rperc'][total.org_cod] = format( '%.2f',(total.soma/somaAN['Eparcial'][total.org_cod])*100 )
      elseif somaAN['Eparcial'][total.org_cod] and tonumber(somaAN['Eparcial'][total.org_cod]) == 0 then          
         somaAN['Rperc'][total.org_cod] = 0
      end
      total = DBRow()
   end
   
   DBExec(queryRealizadoUN)
   total = DBRow()
   
   -- Armazena o percentual REALIZADO das UNs
   while total and total.org_cod do
      if total.unid_cod and somaUN['Eparcial'][total.unid_cod] and tonumber(somaUN['Eparcial'][total.unid_cod]) ~= 0 then          
         somaUN['Rperc'][total.org_cod][total.unid_cod] = format( '%.2f',(total.soma/somaUN['Eparcial'][total.unid_cod])*100 )
      elseif total.unid_cod and somaUN['Eparcial'][total.unid_cod] and tonumber(somaUN['Eparcial'][total.unid_cod]) == 0 then          
         somaUN['Rperc'][total.org_cod][total.unid_cod] = 0
      end
      total = DBRow()
   end
   
   -- -------------------------------------------------
   -- IMPRIMINDO OS PERCENTUAIS FINANCEIROS DE AN E UN 
   -- -------------------------------------------------
   
   i = 1
   if somaAN['Eperc'][i] then      
      while somaAN['Eperc'][i] do               
         DBExec("SELECT org_cod, org_sigla, org_nome FROM orgao WHERE org_cod = '"..somaAN['Eperc'][i]['codigo'].."'" )
         org = DBRow()
         write('<TR><TD COLSPAN=2>&nbsp;</TD></TR>\n')
         write('<TR><TD COLSPAN=2 CLASS="fieldLabel">'..org.org_sigla.. ' - ' ..org.org_nome.. '</TD></TR>\n')
         write('<TR><TD COLSPAN=2>% Total Financeiro Esperado: ' ..gsub(somaAN['Eperc'][i]['valor'], '%.', ',').. '%</TD></TR>\n')
         write('<TR><TD COLSPAN=2>% Total Financeiro Realizado: ' ..gsub((somaAN['Rperc'][org.org_cod] or '0,00'), '%.', ',')..'%</TD></TR>\n')
         write('<TR><TD COLSPAN=2>&nbsp;</TD></TR>\n')
         
         if somaUN['Eperc'][org.org_cod] then            
            un = 1
            while somaUN['Eperc'][org.org_cod][un] do
               DBExec("SELECT unid_cod, unid_sigla, unid_nome FROM unidade WHERE unid_cod = ".. somaUN['Eperc'][org.org_cod][un]['unidade'])
               unid = DBRow()
               write('<TR><TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD><TD CLASS="fieldLabel">'..unid.unid_sigla.. ' - ' ..unid.unid_nome.. '</TD></TR>\n')
               write('<TR><TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD><TD>% Total Financeiro Esperado: ' ..gsub(somaUN['Eperc'][org.org_cod][un]['valor'], '%.', ',').. '%</TD></TR>\n')
               write('<TR><TD>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD><TD>% Total Financeiro Realizado: ' ..gsub((somaUN['Rperc'][org.org_cod][unid.unid_cod] or '0,00'), '%.', ',')..'%</TD></TR>\n')
               write('<TR><TD COLSPAN=2>&nbsp;</TD></TR>\n')
               
               flagUN = 1
               un = un + 1
            end
         end
         
         flagAN = 1
         i = i + 1
      end
   end
   
   if ( temConteudo(cgi.unidade) and cgi.unidade ~= 'TODAS'and flagUN == 0 ) then
      DBExec("SELECT unid_sigla, unid_nome FROM unidade WHERE unid_cod = "..cgi.unidade)
      unidade = DBRow()
      write('<TR><TD COLSPAN=2 class=fieldLabel>No h informaes financeiras para a unidade de negcio '..unidade.unid_sigla..' - '..unidade.unid_nome..'.<BR><BR></TD></TR>\n')
   end
   if ( temConteudo(cgi.orgao) and cgi.orgao ~= 'TODAS'and flagAN == 0 ) then
      DBExec("SELECT org_sigla, org_nome FROM orgao WHERE org_cod = "..cgi.orgao)
      orgao = DBRow()
      write('<TR><TD COLSPAN=2 class=fieldLabel><BR><BR><CENTER>No h informaes financeiras para a rea de negcio '..orgao.org_sigla..' - '..orgao.org_nome..'.<BR><BR></TD></TR>\n')
   end

   write('         </TABLE>\n')
   write('         </TD>\n')
   write('      </TR>\n')
   write('   </TABLE>\n')

   write([[<center><A HREF="../relat_financeiro.html" OnMouseOver="Over('bot-voltar');" OnMouseOut="Out('bot-voltar');"><IMG SRC="../imagens/bot-voltar.gif" BORDER="0" NAME="bot-voltar"></A></center>]])    	                  
   write('</FORM>\n</CENTER>\n')
   write('</BODY>\n')
   write('</HTML>\n')
   
   if ESTADO_BD == 'aberto' then
      FechaBD()
   end

elseif tonumber(cgi.anoIni) > tonumber(cgi.anoFim) then
   if ESTADO_BD == 'aberto' then
      FechaBD()
   end
   cgi.msg = 'O formulrio foi preenchido incorretamente. Siga as instrues junto aos campos que devem ser revistos.'
   cgi.ano = 'O ano de incio no pode ser inferior ao ano de trmino.' 
   cgilua.redirect('../relat_financeiro.html?'..cgilua.encodecgi())          
end